//*****************************************************************************
//  Copyright (c) 2021 Glenfly Tech Co., Ltd..
//  All Rights Reserved.
//
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Glenfly Tech Co., Ltd..;
//  the contents of this file may not be disclosed to third parties, copied or
//  duplicated in any form, in whole or in part, without the prior written
//  permission of Glenfly Tech Co., Ltd..
//
//  The copyright of the source code is protected by the copyright laws of the People's
//  Republic of China and the related laws promulgated by the People's Republic of China
//  and the international covenant(s) ratified by the People's Republic of China.
//*****************************************************************************


/*****************************************************************************
** DESCRIPTION:
** CBios CR, SR groups register macro definition
**
** NOTE:
**
******************************************************************************/

#ifndef _CBIOS_REG_H_
#define _CBIOS_REG_H_

typedef enum _CBIOS_REGISTER_TYPE
{
    CR=0,              /*CR registers           */
    SR,                /*SR registers           */
    AR,
    GR,
    MISC,
    CR_B,               /* B-set of CR */
    CR_C,               /* C-set of CR */
    CR_D,               /* D-set of CR */
    CR_T,               /* CR on IGA3  */
    SR_T,               /* SR on IGA3  */
    SR_B,
    CR_D_0,
    CR_D_1,
    CR_D_2,
    CR_D_3,
    CR_F,
    SR_F,
    RESERVED=0xFF
} CBIOS_REGISTER_TYPE;

typedef struct _CBIOS_PARALLEL_REGISTER
{
    const CBIOS_U32   RegNameIndex;
    CBIOS_U32         RegIndex[4];
} CBIOS_PARALLEL_REGISTER, *PCBIOS_PARALLEL_REGISTER;

#define CR_00 (CR<<8)|0x00
#define CR_01 (CR<<8)|0x01
#define CR_02 (CR<<8)|0x02
#define CR_03 (CR<<8)|0x03
#define CR_04 (CR<<8)|0x04
#define CR_05 (CR<<8)|0x05
#define CR_06 (CR<<8)|0x06
#define CR_07 (CR<<8)|0x07
#define CR_08 (CR<<8)|0x08
#define CR_09 (CR<<8)|0x09
#define CR_0A (CR<<8)|0x0A
#define CR_0B (CR<<8)|0x0B
#define CR_0C (CR<<8)|0x0C
#define CR_0D (CR<<8)|0x0D
#define CR_0E (CR<<8)|0x0E
#define CR_0F (CR<<8)|0x0F
#define CR_10 (CR<<8)|0x10
#define CR_11 (CR<<8)|0x11
#define CR_12 (CR<<8)|0x12
#define CR_13 (CR<<8)|0x13
#define CR_14 (CR<<8)|0x14
#define CR_15 (CR<<8)|0x15
#define CR_16 (CR<<8)|0x16
#define CR_17 (CR<<8)|0x17
#define CR_18 (CR<<8)|0x18
#define CR_19 (CR<<8)|0x19
#define CR_1A (CR<<8)|0x1A
#define CR_1B (CR<<8)|0x1B
#define CR_1C (CR<<8)|0x1C
#define CR_1D (CR<<8)|0x1D
#define CR_1E (CR<<8)|0x1E
#define CR_1F (CR<<8)|0x1F
#define CR_20 (CR<<8)|0x20
#define CR_21 (CR<<8)|0x21
#define CR_22 (CR<<8)|0x22
#define CR_23 (CR<<8)|0x23
#define CR_24 (CR<<8)|0x24
#define CR_25 (CR<<8)|0x25
#define CR_26 (CR<<8)|0x26
#define CR_27 (CR<<8)|0x27
#define CR_28 (CR<<8)|0x28
#define CR_29 (CR<<8)|0x29
#define CR_2A (CR<<8)|0x2A
#define CR_2B (CR<<8)|0x2B
#define CR_2C (CR<<8)|0x2C
#define CR_2D (CR<<8)|0x2D
#define CR_2E (CR<<8)|0x2E
#define CR_2F (CR<<8)|0x2F
#define CR_30 (CR<<8)|0x30
#define CR_31 (CR<<8)|0x31
#define CR_32 (CR<<8)|0x32
#define CR_33 (CR<<8)|0x33
#define CR_34 (CR<<8)|0x34
#define CR_35 (CR<<8)|0x35
#define CR_36 (CR<<8)|0x36
#define CR_37 (CR<<8)|0x37
#define CR_38 (CR<<8)|0x38
#define CR_39 (CR<<8)|0x39
#define CR_3A (CR<<8)|0x3A
#define CR_3B (CR<<8)|0x3B
#define CR_3C (CR<<8)|0x3C
#define CR_3D (CR<<8)|0x3D
#define CR_3E (CR<<8)|0x3E
#define CR_3F (CR<<8)|0x3F
#define CR_40 (CR<<8)|0x40
#define CR_41 (CR<<8)|0x41
#define CR_42 (CR<<8)|0x42
#define CR_43 (CR<<8)|0x43
#define CR_44 (CR<<8)|0x44
#define CR_45 (CR<<8)|0x45
#define CR_46 (CR<<8)|0x46
#define CR_47 (CR<<8)|0x47
#define CR_48 (CR<<8)|0x48
#define CR_49 (CR<<8)|0x49
#define CR_4A (CR<<8)|0x4A
#define CR_4B (CR<<8)|0x4B
#define CR_4C (CR<<8)|0x4C
#define CR_4D (CR<<8)|0x4D
#define CR_4E (CR<<8)|0x4E
#define CR_4F (CR<<8)|0x4F
#define CR_50 (CR<<8)|0x50
#define CR_51 (CR<<8)|0x51
#define CR_52 (CR<<8)|0x52
#define CR_53 (CR<<8)|0x53
#define CR_54 (CR<<8)|0x54
#define CR_55 (CR<<8)|0x55
#define CR_56 (CR<<8)|0x56
#define CR_57 (CR<<8)|0x57
#define CR_58 (CR<<8)|0x58
#define CR_59 (CR<<8)|0x59
#define CR_5A (CR<<8)|0x5A
#define CR_5B (CR<<8)|0x5B
#define CR_5C (CR<<8)|0x5C
#define CR_5D (CR<<8)|0x5D
#define CR_5E (CR<<8)|0x5E
#define CR_5F (CR<<8)|0x5F
#define CR_60 (CR<<8)|0x60
#define CR_61 (CR<<8)|0x61
#define CR_62 (CR<<8)|0x62
#define CR_63 (CR<<8)|0x63
#define CR_64 (CR<<8)|0x64
#define CR_65 (CR<<8)|0x65
#define CR_66 (CR<<8)|0x66
#define CR_67 (CR<<8)|0x67
#define CR_68 (CR<<8)|0x68
#define CR_69 (CR<<8)|0x69
#define CR_6A (CR<<8)|0x6A
#define CR_6B (CR<<8)|0x6B
#define CR_6C (CR<<8)|0x6C
#define CR_6D (CR<<8)|0x6D
#define CR_6E (CR<<8)|0x6E
#define CR_6F (CR<<8)|0x6F
#define CR_70 (CR<<8)|0x70
#define CR_71 (CR<<8)|0x71
#define CR_72 (CR<<8)|0x72
#define CR_73 (CR<<8)|0x73
#define CR_74 (CR<<8)|0x74
#define CR_75 (CR<<8)|0x75
#define CR_76 (CR<<8)|0x76
#define CR_77 (CR<<8)|0x77
#define CR_78 (CR<<8)|0x78
#define CR_79 (CR<<8)|0x79
#define CR_7A (CR<<8)|0x7A
#define CR_7B (CR<<8)|0x7B
#define CR_7C (CR<<8)|0x7C
#define CR_7D (CR<<8)|0x7D
#define CR_7E (CR<<8)|0x7E
#define CR_7F (CR<<8)|0x7F
#define CR_80 (CR<<8)|0x80
#define CR_81 (CR<<8)|0x81
#define CR_82 (CR<<8)|0x82
#define CR_83 (CR<<8)|0x83
#define CR_84 (CR<<8)|0x84
#define CR_85 (CR<<8)|0x85
#define CR_86 (CR<<8)|0x86
#define CR_87 (CR<<8)|0x87
#define CR_88 (CR<<8)|0x88
#define CR_89 (CR<<8)|0x89
#define CR_8A (CR<<8)|0x8A
#define CR_8B (CR<<8)|0x8B
#define CR_8C (CR<<8)|0x8C
#define CR_8D (CR<<8)|0x8D
#define CR_8E (CR<<8)|0x8E
#define CR_8F (CR<<8)|0x8F
#define CR_90 (CR<<8)|0x90
#define CR_91 (CR<<8)|0x91
#define CR_92 (CR<<8)|0x92
#define CR_93 (CR<<8)|0x93
#define CR_94 (CR<<8)|0x94
#define CR_95 (CR<<8)|0x95
#define CR_96 (CR<<8)|0x96
#define CR_97 (CR<<8)|0x97
#define CR_98 (CR<<8)|0x98
#define CR_99 (CR<<8)|0x99
#define CR_9A (CR<<8)|0x9A
#define CR_9B (CR<<8)|0x9B
#define CR_9C (CR<<8)|0x9C
#define CR_9D (CR<<8)|0x9D
#define CR_9E (CR<<8)|0x9E
#define CR_9F (CR<<8)|0x9F
#define CR_A0 (CR<<8)|0xA0
#define CR_A1 (CR<<8)|0xA1
#define CR_A2 (CR<<8)|0xA2
#define CR_A3 (CR<<8)|0xA3
#define CR_A4 (CR<<8)|0xA4
#define CR_A5 (CR<<8)|0xA5
#define CR_A6 (CR<<8)|0xA6
#define CR_A7 (CR<<8)|0xA7
#define CR_A8 (CR<<8)|0xA8
#define CR_A9 (CR<<8)|0xA9
#define CR_AA (CR<<8)|0xAA
#define CR_AB (CR<<8)|0xAB
#define CR_AC (CR<<8)|0xAC
#define CR_AD (CR<<8)|0xAD
#define CR_AE (CR<<8)|0xAE
#define CR_AF (CR<<8)|0xAF
#define CR_B0 (CR<<8)|0xB0
#define CR_B1 (CR<<8)|0xB1
#define CR_B2 (CR<<8)|0xB2
#define CR_B3 (CR<<8)|0xB3
#define CR_B4 (CR<<8)|0xB4
#define CR_B5 (CR<<8)|0xB5
#define CR_B6 (CR<<8)|0xB6
#define CR_B7 (CR<<8)|0xB7
#define CR_B8 (CR<<8)|0xB8
#define CR_B9 (CR<<8)|0xB9
#define CR_BA (CR<<8)|0xBA
#define CR_BB (CR<<8)|0xBB
#define CR_BC (CR<<8)|0xBC
#define CR_BD (CR<<8)|0xBD
#define CR_BE (CR<<8)|0xBE
#define CR_BF (CR<<8)|0xBF
#define CR_C0 (CR<<8)|0xC0
#define CR_C1 (CR<<8)|0xC1
#define CR_C2 (CR<<8)|0xC2
#define CR_C3 (CR<<8)|0xC3
#define CR_C4 (CR<<8)|0xC4
#define CR_C5 (CR<<8)|0xC5
#define CR_C6 (CR<<8)|0xC6
#define CR_C7 (CR<<8)|0xC7
#define CR_C8 (CR<<8)|0xC8
#define CR_C9 (CR<<8)|0xC9
#define CR_CA (CR<<8)|0xCA
#define CR_CB (CR<<8)|0xCB
#define CR_CC (CR<<8)|0xCC
#define CR_CD (CR<<8)|0xCD
#define CR_CE (CR<<8)|0xCE
#define CR_CF (CR<<8)|0xCF
#define CR_D0 (CR<<8)|0xD0
#define CR_D1 (CR<<8)|0xD1
#define CR_D2 (CR<<8)|0xD2
#define CR_D3 (CR<<8)|0xD3
#define CR_D4 (CR<<8)|0xD4
#define CR_D5 (CR<<8)|0xD5
#define CR_D6 (CR<<8)|0xD6
#define CR_D7 (CR<<8)|0xD7
#define CR_D8 (CR<<8)|0xD8
#define CR_D9 (CR<<8)|0xD9
#define CR_DA (CR<<8)|0xDA
#define CR_DB (CR<<8)|0xDB
#define CR_DC (CR<<8)|0xDC
#define CR_DD (CR<<8)|0xDD
#define CR_DE (CR<<8)|0xDE
#define CR_DF (CR<<8)|0xDF
#define CR_E0 (CR<<8)|0xE0
#define CR_E1 (CR<<8)|0xE1
#define CR_E2 (CR<<8)|0xE2
#define CR_E3 (CR<<8)|0xE3
#define CR_E4 (CR<<8)|0xE4
#define CR_E5 (CR<<8)|0xE5
#define CR_E6 (CR<<8)|0xE6
#define CR_E7 (CR<<8)|0xE7
#define CR_E8 (CR<<8)|0xE8
#define CR_E9 (CR<<8)|0xE9
#define CR_EA (CR<<8)|0xEA
#define CR_EB (CR<<8)|0xEB
#define CR_EC (CR<<8)|0xEC
#define CR_ED (CR<<8)|0xED
#define CR_EE (CR<<8)|0xEE
#define CR_EF (CR<<8)|0xEF
#define CR_F0 (CR<<8)|0xF0
#define CR_F1 (CR<<8)|0xF1
#define CR_F2 (CR<<8)|0xF2
#define CR_F3 (CR<<8)|0xF3
#define CR_F4 (CR<<8)|0xF4
#define CR_F5 (CR<<8)|0xF5
#define CR_F6 (CR<<8)|0xF6
#define CR_F7 (CR<<8)|0xF7
#define CR_F8 (CR<<8)|0xF8
#define CR_F9 (CR<<8)|0xF9
#define CR_FA (CR<<8)|0xFA
#define CR_FB (CR<<8)|0xFB
#define CR_FC (CR<<8)|0xFC
#define CR_FD (CR<<8)|0xFD
#define CR_FE (CR<<8)|0xFE
#define CR_FF (CR<<8)|0xFF

#define SR_00 (SR<<8)|0x00
#define SR_01 (SR<<8)|0x01
#define SR_02 (SR<<8)|0x02
#define SR_03 (SR<<8)|0x03
#define SR_04 (SR<<8)|0x04
#define SR_05 (SR<<8)|0x05
#define SR_06 (SR<<8)|0x06
#define SR_07 (SR<<8)|0x07
#define SR_08 (SR<<8)|0x08
#define SR_09 (SR<<8)|0x09
#define SR_0A (SR<<8)|0x0A
#define SR_0B (SR<<8)|0x0B
#define SR_0C (SR<<8)|0x0C
#define SR_0D (SR<<8)|0x0D
#define SR_0E (SR<<8)|0x0E
#define SR_0F (SR<<8)|0x0F
#define SR_10 (SR<<8)|0x10
#define SR_11 (SR<<8)|0x11
#define SR_12 (SR<<8)|0x12
#define SR_13 (SR<<8)|0x13
#define SR_14 (SR<<8)|0x14
#define SR_15 (SR<<8)|0x15
#define SR_16 (SR<<8)|0x16
#define SR_17 (SR<<8)|0x17
#define SR_18 (SR<<8)|0x18
#define SR_19 (SR<<8)|0x19
#define SR_1A (SR<<8)|0x1A
#define SR_1B (SR<<8)|0x1B
#define SR_1C (SR<<8)|0x1C
#define SR_1D (SR<<8)|0x1D
#define SR_1E (SR<<8)|0x1E
#define SR_1F (SR<<8)|0x1F
#define SR_20 (SR<<8)|0x20
#define SR_21 (SR<<8)|0x21
#define SR_22 (SR<<8)|0x22
#define SR_23 (SR<<8)|0x23
#define SR_24 (SR<<8)|0x24
#define SR_25 (SR<<8)|0x25
#define SR_26 (SR<<8)|0x26
#define SR_27 (SR<<8)|0x27
#define SR_28 (SR<<8)|0x28
#define SR_29 (SR<<8)|0x29
#define SR_2A (SR<<8)|0x2A
#define SR_2B (SR<<8)|0x2B
#define SR_2C (SR<<8)|0x2C
#define SR_2D (SR<<8)|0x2D
#define SR_2E (SR<<8)|0x2E
#define SR_2F (SR<<8)|0x2F
#define SR_30 (SR<<8)|0x30
#define SR_31 (SR<<8)|0x31
#define SR_32 (SR<<8)|0x32
#define SR_33 (SR<<8)|0x33
#define SR_34 (SR<<8)|0x34
#define SR_35 (SR<<8)|0x35
#define SR_36 (SR<<8)|0x36
#define SR_37 (SR<<8)|0x37
#define SR_38 (SR<<8)|0x38
#define SR_39 (SR<<8)|0x39
#define SR_3A (SR<<8)|0x3A
#define SR_3B (SR<<8)|0x3B
#define SR_3C (SR<<8)|0x3C
#define SR_3D (SR<<8)|0x3D
#define SR_3E (SR<<8)|0x3E
#define SR_3F (SR<<8)|0x3F
#define SR_40 (SR<<8)|0x40
#define SR_41 (SR<<8)|0x41
#define SR_42 (SR<<8)|0x42
#define SR_43 (SR<<8)|0x43
#define SR_44 (SR<<8)|0x44
#define SR_45 (SR<<8)|0x45
#define SR_46 (SR<<8)|0x46
#define SR_47 (SR<<8)|0x47
#define SR_48 (SR<<8)|0x48
#define SR_49 (SR<<8)|0x49
#define SR_4A (SR<<8)|0x4A
#define SR_4B (SR<<8)|0x4B
#define SR_4C (SR<<8)|0x4C
#define SR_4D (SR<<8)|0x4D
#define SR_4E (SR<<8)|0x4E
#define SR_4F (SR<<8)|0x4F
#define SR_50 (SR<<8)|0x50
#define SR_51 (SR<<8)|0x51
#define SR_52 (SR<<8)|0x52
#define SR_53 (SR<<8)|0x53
#define SR_54 (SR<<8)|0x54
#define SR_55 (SR<<8)|0x55
#define SR_56 (SR<<8)|0x56
#define SR_57 (SR<<8)|0x57
#define SR_58 (SR<<8)|0x58
#define SR_59 (SR<<8)|0x59
#define SR_5A (SR<<8)|0x5A
#define SR_5B (SR<<8)|0x5B
#define SR_5C (SR<<8)|0x5C
#define SR_5D (SR<<8)|0x5D
#define SR_5E (SR<<8)|0x5E
#define SR_5F (SR<<8)|0x5F
#define SR_60 (SR<<8)|0x60
#define SR_61 (SR<<8)|0x61
#define SR_62 (SR<<8)|0x62
#define SR_63 (SR<<8)|0x63
#define SR_64 (SR<<8)|0x64
#define SR_65 (SR<<8)|0x65
#define SR_66 (SR<<8)|0x66
#define SR_67 (SR<<8)|0x67
#define SR_68 (SR<<8)|0x68
#define SR_69 (SR<<8)|0x69
#define SR_6A (SR<<8)|0x6A
#define SR_6B (SR<<8)|0x6B
#define SR_6C (SR<<8)|0x6C
#define SR_6D (SR<<8)|0x6D
#define SR_6E (SR<<8)|0x6E
#define SR_6F (SR<<8)|0x6F
#define SR_70 (SR<<8)|0x70
#define SR_71 (SR<<8)|0x71
#define SR_72 (SR<<8)|0x72
#define SR_73 (SR<<8)|0x73
#define SR_74 (SR<<8)|0x74
#define SR_75 (SR<<8)|0x75
#define SR_76 (SR<<8)|0x76
#define SR_77 (SR<<8)|0x77
#define SR_78 (SR<<8)|0x78
#define SR_79 (SR<<8)|0x79
#define SR_7A (SR<<8)|0x7A
#define SR_7B (SR<<8)|0x7B
#define SR_7C (SR<<8)|0x7C
#define SR_7D (SR<<8)|0x7D
#define SR_7E (SR<<8)|0x7E
#define SR_7F (SR<<8)|0x7F
#define SR_80 (SR<<8)|0x80
#define SR_81 (SR<<8)|0x81
#define SR_82 (SR<<8)|0x82
#define SR_83 (SR<<8)|0x83
#define SR_84 (SR<<8)|0x84
#define SR_85 (SR<<8)|0x85
#define SR_86 (SR<<8)|0x86
#define SR_87 (SR<<8)|0x87
#define SR_88 (SR<<8)|0x88
#define SR_89 (SR<<8)|0x89
#define SR_8A (SR<<8)|0x8A
#define SR_8B (SR<<8)|0x8B
#define SR_8C (SR<<8)|0x8C
#define SR_8D (SR<<8)|0x8D
#define SR_8E (SR<<8)|0x8E
#define SR_8F (SR<<8)|0x8F
#define SR_90 (SR<<8)|0x90
#define SR_91 (SR<<8)|0x91
#define SR_92 (SR<<8)|0x92
#define SR_93 (SR<<8)|0x93
#define SR_94 (SR<<8)|0x94
#define SR_95 (SR<<8)|0x95
#define SR_96 (SR<<8)|0x96
#define SR_97 (SR<<8)|0x97
#define SR_98 (SR<<8)|0x98
#define SR_99 (SR<<8)|0x99
#define SR_9A (SR<<8)|0x9A
#define SR_9B (SR<<8)|0x9B
#define SR_9C (SR<<8)|0x9C
#define SR_9D (SR<<8)|0x9D
#define SR_9E (SR<<8)|0x9E
#define SR_9F (SR<<8)|0x9F
#define SR_A0 (SR<<8)|0xA0
#define SR_A1 (SR<<8)|0xA1
#define SR_A2 (SR<<8)|0xA2
#define SR_A3 (SR<<8)|0xA3
#define SR_A4 (SR<<8)|0xA4
#define SR_A5 (SR<<8)|0xA5
#define SR_A6 (SR<<8)|0xA6
#define SR_A7 (SR<<8)|0xA7
#define SR_A8 (SR<<8)|0xA8
#define SR_A9 (SR<<8)|0xA9
#define SR_AA (SR<<8)|0xAA
#define SR_AB (SR<<8)|0xAB
#define SR_AC (SR<<8)|0xAC
#define SR_AD (SR<<8)|0xAD
#define SR_AE (SR<<8)|0xAE
#define SR_AF (SR<<8)|0xAF
#define SR_B0 (SR<<8)|0xB0
#define SR_B1 (SR<<8)|0xB1
#define SR_B2 (SR<<8)|0xB2
#define SR_B3 (SR<<8)|0xB3
#define SR_B4 (SR<<8)|0xB4
#define SR_B5 (SR<<8)|0xB5
#define SR_B6 (SR<<8)|0xB6
#define SR_B7 (SR<<8)|0xB7
#define SR_B8 (SR<<8)|0xB8
#define SR_B9 (SR<<8)|0xB9
#define SR_BA (SR<<8)|0xBA
#define SR_BB (SR<<8)|0xBB
#define SR_BC (SR<<8)|0xBC
#define SR_BD (SR<<8)|0xBD
#define SR_BE (SR<<8)|0xBE
#define SR_BF (SR<<8)|0xBF
#define SR_C0 (SR<<8)|0xC0
#define SR_C1 (SR<<8)|0xC1
#define SR_C2 (SR<<8)|0xC2
#define SR_C3 (SR<<8)|0xC3
#define SR_C4 (SR<<8)|0xC4
#define SR_C5 (SR<<8)|0xC5
#define SR_C6 (SR<<8)|0xC6
#define SR_C7 (SR<<8)|0xC7
#define SR_C8 (SR<<8)|0xC8
#define SR_C9 (SR<<8)|0xC9
#define SR_CA (SR<<8)|0xCA
#define SR_CB (SR<<8)|0xCB
#define SR_CC (SR<<8)|0xCC
#define SR_CD (SR<<8)|0xCD
#define SR_CE (SR<<8)|0xCE
#define SR_CF (SR<<8)|0xCF
#define SR_D0 (SR<<8)|0xD0
#define SR_D1 (SR<<8)|0xD1
#define SR_D2 (SR<<8)|0xD2
#define SR_D3 (SR<<8)|0xD3
#define SR_D4 (SR<<8)|0xD4
#define SR_D5 (SR<<8)|0xD5
#define SR_D6 (SR<<8)|0xD6
#define SR_D7 (SR<<8)|0xD7
#define SR_D8 (SR<<8)|0xD8
#define SR_D9 (SR<<8)|0xD9
#define SR_DA (SR<<8)|0xDA
#define SR_DB (SR<<8)|0xDB
#define SR_DC (SR<<8)|0xDC
#define SR_DD (SR<<8)|0xDD
#define SR_DE (SR<<8)|0xDE
#define SR_DF (SR<<8)|0xDF
#define SR_E0 (SR<<8)|0xE0
#define SR_E1 (SR<<8)|0xE1
#define SR_E2 (SR<<8)|0xE2
#define SR_E3 (SR<<8)|0xE3
#define SR_E4 (SR<<8)|0xE4
#define SR_E5 (SR<<8)|0xE5
#define SR_E6 (SR<<8)|0xE6
#define SR_E7 (SR<<8)|0xE7
#define SR_E8 (SR<<8)|0xE8
#define SR_E9 (SR<<8)|0xE9
#define SR_EA (SR<<8)|0xEA
#define SR_EB (SR<<8)|0xEB
#define SR_EC (SR<<8)|0xEC
#define SR_ED (SR<<8)|0xED
#define SR_EE (SR<<8)|0xEE
#define SR_EF (SR<<8)|0xEF
#define SR_F0 (SR<<8)|0xF0
#define SR_F1 (SR<<8)|0xF1
#define SR_F2 (SR<<8)|0xF2
#define SR_F3 (SR<<8)|0xF3
#define SR_F4 (SR<<8)|0xF4
#define SR_F5 (SR<<8)|0xF5
#define SR_F6 (SR<<8)|0xF6
#define SR_F7 (SR<<8)|0xF7
#define SR_F8 (SR<<8)|0xF8
#define SR_F9 (SR<<8)|0xF9
#define SR_FA (SR<<8)|0xFA
#define SR_FB (SR<<8)|0xFB
#define SR_FC (SR<<8)|0xFC
#define SR_FD (SR<<8)|0xFD
#define SR_FE (SR<<8)|0xFE
#define SR_FF (SR<<8)|0xFF

#define SR_T_00 (SR_T<<8)|0x00
#define SR_T_01 (SR_T<<8)|0x01
#define SR_T_02 (SR_T<<8)|0x02
#define SR_T_03 (SR_T<<8)|0x03
#define SR_T_04 (SR_T<<8)|0x04
#define SR_T_05 (SR_T<<8)|0x05
#define SR_T_06 (SR_T<<8)|0x06
#define SR_T_07 (SR_T<<8)|0x07
#define SR_T_08 (SR_T<<8)|0x08
#define SR_T_09 (SR_T<<8)|0x09
#define SR_T_0A (SR_T<<8)|0x0A
#define SR_T_0B (SR_T<<8)|0x0B
#define SR_T_0C (SR_T<<8)|0x0C
#define SR_T_0D (SR_T<<8)|0x0D
#define SR_T_0E (SR_T<<8)|0x0E
#define SR_T_0F (SR_T<<8)|0x0F
#define SR_T_10 (SR_T<<8)|0x10
#define SR_T_11 (SR_T<<8)|0x11
#define SR_T_12 (SR_T<<8)|0x12
#define SR_T_13 (SR_T<<8)|0x13
#define SR_T_14 (SR_T<<8)|0x14
#define SR_T_15 (SR_T<<8)|0x15
#define SR_T_16 (SR_T<<8)|0x16
#define SR_T_17 (SR_T<<8)|0x17
#define SR_T_18 (SR_T<<8)|0x18
#define SR_T_19 (SR_T<<8)|0x19
#define SR_T_1A (SR_T<<8)|0x1A
#define SR_T_1B (SR_T<<8)|0x1B
#define SR_T_1C (SR_T<<8)|0x1C
#define SR_T_1D (SR_T<<8)|0x1D
#define SR_T_1E (SR_T<<8)|0x1E
#define SR_T_1F (SR_T<<8)|0x1F
#define SR_T_20 (SR_T<<8)|0x20
#define SR_T_21 (SR_T<<8)|0x21
#define SR_T_22 (SR_T<<8)|0x22
#define SR_T_23 (SR_T<<8)|0x23
#define SR_T_24 (SR_T<<8)|0x24
#define SR_T_25 (SR_T<<8)|0x25
#define SR_T_26 (SR_T<<8)|0x26
#define SR_T_27 (SR_T<<8)|0x27
#define SR_T_28 (SR_T<<8)|0x28
#define SR_T_29 (SR_T<<8)|0x29
#define SR_T_2A (SR_T<<8)|0x2A
#define SR_T_2B (SR_T<<8)|0x2B
#define SR_T_2C (SR_T<<8)|0x2C
#define SR_T_2D (SR_T<<8)|0x2D
#define SR_T_2E (SR_T<<8)|0x2E
#define SR_T_2F (SR_T<<8)|0x2F
#define SR_T_30 (SR_T<<8)|0x30
#define SR_T_31 (SR_T<<8)|0x31
#define SR_T_32 (SR_T<<8)|0x32
#define SR_T_33 (SR_T<<8)|0x33
#define SR_T_34 (SR_T<<8)|0x34
#define SR_T_35 (SR_T<<8)|0x35
#define SR_T_36 (SR_T<<8)|0x36
#define SR_T_37 (SR_T<<8)|0x37
#define SR_T_38 (SR_T<<8)|0x38
#define SR_T_39 (SR_T<<8)|0x39
#define SR_T_3A (SR_T<<8)|0x3A
#define SR_T_3B (SR_T<<8)|0x3B
#define SR_T_3C (SR_T<<8)|0x3C
#define SR_T_3D (SR_T<<8)|0x3D
#define SR_T_3E (SR_T<<8)|0x3E
#define SR_T_3F (SR_T<<8)|0x3F
#define SR_T_40 (SR_T<<8)|0x40
#define SR_T_41 (SR_T<<8)|0x41
#define SR_T_42 (SR_T<<8)|0x42
#define SR_T_43 (SR_T<<8)|0x43
#define SR_T_44 (SR_T<<8)|0x44
#define SR_T_45 (SR_T<<8)|0x45
#define SR_T_46 (SR_T<<8)|0x46
#define SR_T_47 (SR_T<<8)|0x47
#define SR_T_48 (SR_T<<8)|0x48
#define SR_T_49 (SR_T<<8)|0x49
#define SR_T_4A (SR_T<<8)|0x4A
#define SR_T_4B (SR_T<<8)|0x4B
#define SR_T_4C (SR_T<<8)|0x4C
#define SR_T_4D (SR_T<<8)|0x4D
#define SR_T_4E (SR_T<<8)|0x4E
#define SR_T_4F (SR_T<<8)|0x4F
#define SR_T_50 (SR_T<<8)|0x50
#define SR_T_51 (SR_T<<8)|0x51
#define SR_T_52 (SR_T<<8)|0x52
#define SR_T_53 (SR_T<<8)|0x53
#define SR_T_54 (SR_T<<8)|0x54
#define SR_T_55 (SR_T<<8)|0x55
#define SR_T_56 (SR_T<<8)|0x56
#define SR_T_57 (SR_T<<8)|0x57
#define SR_T_58 (SR_T<<8)|0x58
#define SR_T_59 (SR_T<<8)|0x59
#define SR_T_5A (SR_T<<8)|0x5A
#define SR_T_5B (SR_T<<8)|0x5B
#define SR_T_5C (SR_T<<8)|0x5C
#define SR_T_5D (SR_T<<8)|0x5D
#define SR_T_5E (SR_T<<8)|0x5E
#define SR_T_5F (SR_T<<8)|0x5F
#define SR_T_60 (SR_T<<8)|0x60
#define SR_T_61 (SR_T<<8)|0x61
#define SR_T_62 (SR_T<<8)|0x62
#define SR_T_63 (SR_T<<8)|0x63
#define SR_T_64 (SR_T<<8)|0x64
#define SR_T_65 (SR_T<<8)|0x65
#define SR_T_66 (SR_T<<8)|0x66
#define SR_T_67 (SR_T<<8)|0x67
#define SR_T_68 (SR_T<<8)|0x68
#define SR_T_69 (SR_T<<8)|0x69
#define SR_T_6A (SR_T<<8)|0x6A
#define SR_T_6B (SR_T<<8)|0x6B
#define SR_T_6C (SR_T<<8)|0x6C
#define SR_T_6D (SR_T<<8)|0x6D
#define SR_T_6E (SR_T<<8)|0x6E
#define SR_T_6F (SR_T<<8)|0x6F
#define SR_T_70 (SR_T<<8)|0x70
#define SR_T_71 (SR_T<<8)|0x71
#define SR_T_72 (SR_T<<8)|0x72
#define SR_T_73 (SR_T<<8)|0x73
#define SR_T_74 (SR_T<<8)|0x74
#define SR_T_75 (SR_T<<8)|0x75
#define SR_T_76 (SR_T<<8)|0x76
#define SR_T_77 (SR_T<<8)|0x77
#define SR_T_78 (SR_T<<8)|0x78
#define SR_T_79 (SR_T<<8)|0x79
#define SR_T_7A (SR_T<<8)|0x7A
#define SR_T_7B (SR_T<<8)|0x7B
#define SR_T_7C (SR_T<<8)|0x7C
#define SR_T_7D (SR_T<<8)|0x7D
#define SR_T_7E (SR_T<<8)|0x7E
#define SR_T_7F (SR_T<<8)|0x7F
#define SR_T_80 (SR_T<<8)|0x80
#define SR_T_81 (SR_T<<8)|0x81
#define SR_T_82 (SR_T<<8)|0x82
#define SR_T_83 (SR_T<<8)|0x83
#define SR_T_84 (SR_T<<8)|0x84
#define SR_T_85 (SR_T<<8)|0x85
#define SR_T_86 (SR_T<<8)|0x86
#define SR_T_87 (SR_T<<8)|0x87
#define SR_T_88 (SR_T<<8)|0x88
#define SR_T_89 (SR_T<<8)|0x89
#define SR_T_8A (SR_T<<8)|0x8A
#define SR_T_8B (SR_T<<8)|0x8B
#define SR_T_8C (SR_T<<8)|0x8C
#define SR_T_8D (SR_T<<8)|0x8D
#define SR_T_8E (SR_T<<8)|0x8E
#define SR_T_8F (SR_T<<8)|0x8F
#define SR_T_90 (SR_T<<8)|0x90
#define SR_T_91 (SR_T<<8)|0x91
#define SR_T_92 (SR_T<<8)|0x92
#define SR_T_93 (SR_T<<8)|0x93
#define SR_T_94 (SR_T<<8)|0x94
#define SR_T_95 (SR_T<<8)|0x95
#define SR_T_96 (SR_T<<8)|0x96
#define SR_T_97 (SR_T<<8)|0x97
#define SR_T_98 (SR_T<<8)|0x98
#define SR_T_99 (SR_T<<8)|0x99
#define SR_T_9A (SR_T<<8)|0x9A
#define SR_T_9B (SR_T<<8)|0x9B
#define SR_T_9C (SR_T<<8)|0x9C
#define SR_T_9D (SR_T<<8)|0x9D
#define SR_T_9E (SR_T<<8)|0x9E
#define SR_T_9F (SR_T<<8)|0x9F
#define SR_T_A0 (SR_T<<8)|0xA0
#define SR_T_A1 (SR_T<<8)|0xA1
#define SR_T_A2 (SR_T<<8)|0xA2
#define SR_T_A3 (SR_T<<8)|0xA3
#define SR_T_A4 (SR_T<<8)|0xA4
#define SR_T_A5 (SR_T<<8)|0xA5
#define SR_T_A6 (SR_T<<8)|0xA6
#define SR_T_A7 (SR_T<<8)|0xA7
#define SR_T_A8 (SR_T<<8)|0xA8
#define SR_T_A9 (SR_T<<8)|0xA9
#define SR_T_AA (SR_T<<8)|0xAA
#define SR_T_AB (SR_T<<8)|0xAB
#define SR_T_AC (SR_T<<8)|0xAC
#define SR_T_AD (SR_T<<8)|0xAD
#define SR_T_AE (SR_T<<8)|0xAE
#define SR_T_AF (SR_T<<8)|0xAF
#define SR_T_B0 (SR_T<<8)|0xB0
#define SR_T_B1 (SR_T<<8)|0xB1
#define SR_T_B2 (SR_T<<8)|0xB2
#define SR_T_B3 (SR_T<<8)|0xB3
#define SR_T_B4 (SR_T<<8)|0xB4
#define SR_T_B5 (SR_T<<8)|0xB5
#define SR_T_B6 (SR_T<<8)|0xB6
#define SR_T_B7 (SR_T<<8)|0xB7
#define SR_T_B8 (SR_T<<8)|0xB8
#define SR_T_B9 (SR_T<<8)|0xB9
#define SR_T_BA (SR_T<<8)|0xBA
#define SR_T_BB (SR_T<<8)|0xBB
#define SR_T_BC (SR_T<<8)|0xBC
#define SR_T_BD (SR_T<<8)|0xBD
#define SR_T_BE (SR_T<<8)|0xBE
#define SR_T_BF (SR_T<<8)|0xBF
#define SR_T_C0 (SR_T<<8)|0xC0
#define SR_T_C1 (SR_T<<8)|0xC1
#define SR_T_C2 (SR_T<<8)|0xC2
#define SR_T_C3 (SR_T<<8)|0xC3
#define SR_T_C4 (SR_T<<8)|0xC4
#define SR_T_C5 (SR_T<<8)|0xC5
#define SR_T_C6 (SR_T<<8)|0xC6
#define SR_T_C7 (SR_T<<8)|0xC7
#define SR_T_C8 (SR_T<<8)|0xC8
#define SR_T_C9 (SR_T<<8)|0xC9
#define SR_T_CA (SR_T<<8)|0xCA
#define SR_T_CB (SR_T<<8)|0xCB
#define SR_T_CC (SR_T<<8)|0xCC
#define SR_T_CD (SR_T<<8)|0xCD
#define SR_T_CE (SR_T<<8)|0xCE
#define SR_T_CF (SR_T<<8)|0xCF
#define SR_T_D0 (SR_T<<8)|0xD0
#define SR_T_D1 (SR_T<<8)|0xD1
#define SR_T_D2 (SR_T<<8)|0xD2
#define SR_T_D3 (SR_T<<8)|0xD3
#define SR_T_D4 (SR_T<<8)|0xD4
#define SR_T_D5 (SR_T<<8)|0xD5
#define SR_T_D6 (SR_T<<8)|0xD6
#define SR_T_D7 (SR_T<<8)|0xD7
#define SR_T_D8 (SR_T<<8)|0xD8
#define SR_T_D9 (SR_T<<8)|0xD9
#define SR_T_DA (SR_T<<8)|0xDA
#define SR_T_DB (SR_T<<8)|0xDB
#define SR_T_DC (SR_T<<8)|0xDC
#define SR_T_DD (SR_T<<8)|0xDD
#define SR_T_DE (SR_T<<8)|0xDE
#define SR_T_DF (SR_T<<8)|0xDF
#define SR_T_E0 (SR_T<<8)|0xE0
#define SR_T_E1 (SR_T<<8)|0xE1
#define SR_T_E2 (SR_T<<8)|0xE2
#define SR_T_E3 (SR_T<<8)|0xE3
#define SR_T_E4 (SR_T<<8)|0xE4
#define SR_T_E5 (SR_T<<8)|0xE5
#define SR_T_E6 (SR_T<<8)|0xE6
#define SR_T_E7 (SR_T<<8)|0xE7
#define SR_T_E8 (SR_T<<8)|0xE8
#define SR_T_E9 (SR_T<<8)|0xE9
#define SR_T_EA (SR_T<<8)|0xEA
#define SR_T_EB (SR_T<<8)|0xEB
#define SR_T_EC (SR_T<<8)|0xEC
#define SR_T_ED (SR_T<<8)|0xED
#define SR_T_EE (SR_T<<8)|0xEE
#define SR_T_EF (SR_T<<8)|0xEF
#define SR_T_F0 (SR_T<<8)|0xF0
#define SR_T_F1 (SR_T<<8)|0xF1
#define SR_T_F2 (SR_T<<8)|0xF2
#define SR_T_F3 (SR_T<<8)|0xF3
#define SR_T_F4 (SR_T<<8)|0xF4
#define SR_T_F5 (SR_T<<8)|0xF5
#define SR_T_F6 (SR_T<<8)|0xF6
#define SR_T_F7 (SR_T<<8)|0xF7
#define SR_T_F8 (SR_T<<8)|0xF8
#define SR_T_F9 (SR_T<<8)|0xF9
#define SR_T_FA (SR_T<<8)|0xFA
#define SR_T_FB (SR_T<<8)|0xFB
#define SR_T_FC (SR_T<<8)|0xFC
#define SR_T_FD (SR_T<<8)|0xFD
#define SR_T_FE (SR_T<<8)|0xFE
#define SR_T_FF (SR_T<<8)|0xFF

#define CR_B_00 (CR_B<<8)|0x00
#define CR_B_01 (CR_B<<8)|0x01
#define CR_B_02 (CR_B<<8)|0x02
#define CR_B_03 (CR_B<<8)|0x03
#define CR_B_04 (CR_B<<8)|0x04
#define CR_B_05 (CR_B<<8)|0x05
#define CR_B_06 (CR_B<<8)|0x06
#define CR_B_07 (CR_B<<8)|0x07
#define CR_B_08 (CR_B<<8)|0x08
#define CR_B_09 (CR_B<<8)|0x09
#define CR_B_0A (CR_B<<8)|0x0A
#define CR_B_0B (CR_B<<8)|0x0B
#define CR_B_0C (CR_B<<8)|0x0C
#define CR_B_0D (CR_B<<8)|0x0D
#define CR_B_0E (CR_B<<8)|0x0E
#define CR_B_0F (CR_B<<8)|0x0F
#define CR_B_10 (CR_B<<8)|0x10
#define CR_B_11 (CR_B<<8)|0x11
#define CR_B_12 (CR_B<<8)|0x12
#define CR_B_13 (CR_B<<8)|0x13
#define CR_B_14 (CR_B<<8)|0x14
#define CR_B_15 (CR_B<<8)|0x15
#define CR_B_16 (CR_B<<8)|0x16
#define CR_B_17 (CR_B<<8)|0x17
#define CR_B_18 (CR_B<<8)|0x18
#define CR_B_19 (CR_B<<8)|0x19
#define CR_B_1A (CR_B<<8)|0x1A
#define CR_B_1B (CR_B<<8)|0x1B
#define CR_B_1C (CR_B<<8)|0x1C
#define CR_B_1D (CR_B<<8)|0x1D
#define CR_B_1E (CR_B<<8)|0x1E
#define CR_B_1F (CR_B<<8)|0x1F
#define CR_B_20 (CR_B<<8)|0x20
#define CR_B_21 (CR_B<<8)|0x21
#define CR_B_22 (CR_B<<8)|0x22
#define CR_B_23 (CR_B<<8)|0x23
#define CR_B_24 (CR_B<<8)|0x24
#define CR_B_25 (CR_B<<8)|0x25
#define CR_B_26 (CR_B<<8)|0x26
#define CR_B_27 (CR_B<<8)|0x27
#define CR_B_28 (CR_B<<8)|0x28
#define CR_B_29 (CR_B<<8)|0x29
#define CR_B_2A (CR_B<<8)|0x2A
#define CR_B_2B (CR_B<<8)|0x2B
#define CR_B_2C (CR_B<<8)|0x2C
#define CR_B_2D (CR_B<<8)|0x2D
#define CR_B_2E (CR_B<<8)|0x2E
#define CR_B_2F (CR_B<<8)|0x2F
#define CR_B_30 (CR_B<<8)|0x30
#define CR_B_31 (CR_B<<8)|0x31
#define CR_B_32 (CR_B<<8)|0x32
#define CR_B_33 (CR_B<<8)|0x33
#define CR_B_34 (CR_B<<8)|0x34
#define CR_B_35 (CR_B<<8)|0x35
#define CR_B_36 (CR_B<<8)|0x36
#define CR_B_37 (CR_B<<8)|0x37
#define CR_B_38 (CR_B<<8)|0x38
#define CR_B_39 (CR_B<<8)|0x39
#define CR_B_3A (CR_B<<8)|0x3A
#define CR_B_3B (CR_B<<8)|0x3B
#define CR_B_3C (CR_B<<8)|0x3C
#define CR_B_3D (CR_B<<8)|0x3D
#define CR_B_3E (CR_B<<8)|0x3E
#define CR_B_3F (CR_B<<8)|0x3F
#define CR_B_40 (CR_B<<8)|0x40
#define CR_B_41 (CR_B<<8)|0x41
#define CR_B_42 (CR_B<<8)|0x42
#define CR_B_43 (CR_B<<8)|0x43
#define CR_B_44 (CR_B<<8)|0x44
#define CR_B_45 (CR_B<<8)|0x45
#define CR_B_46 (CR_B<<8)|0x46
#define CR_B_47 (CR_B<<8)|0x47
#define CR_B_48 (CR_B<<8)|0x48
#define CR_B_49 (CR_B<<8)|0x49
#define CR_B_4A (CR_B<<8)|0x4A
#define CR_B_4B (CR_B<<8)|0x4B
#define CR_B_4C (CR_B<<8)|0x4C
#define CR_B_4D (CR_B<<8)|0x4D
#define CR_B_4E (CR_B<<8)|0x4E
#define CR_B_4F (CR_B<<8)|0x4F
#define CR_B_50 (CR_B<<8)|0x50
#define CR_B_51 (CR_B<<8)|0x51
#define CR_B_52 (CR_B<<8)|0x52
#define CR_B_53 (CR_B<<8)|0x53
#define CR_B_54 (CR_B<<8)|0x54
#define CR_B_55 (CR_B<<8)|0x55
#define CR_B_56 (CR_B<<8)|0x56
#define CR_B_57 (CR_B<<8)|0x57
#define CR_B_58 (CR_B<<8)|0x58
#define CR_B_59 (CR_B<<8)|0x59
#define CR_B_5A (CR_B<<8)|0x5A
#define CR_B_5B (CR_B<<8)|0x5B
#define CR_B_5C (CR_B<<8)|0x5C
#define CR_B_5D (CR_B<<8)|0x5D
#define CR_B_5E (CR_B<<8)|0x5E
#define CR_B_5F (CR_B<<8)|0x5F
#define CR_B_60 (CR_B<<8)|0x60
#define CR_B_61 (CR_B<<8)|0x61
#define CR_B_62 (CR_B<<8)|0x62
#define CR_B_63 (CR_B<<8)|0x63
#define CR_B_64 (CR_B<<8)|0x64
#define CR_B_65 (CR_B<<8)|0x65
#define CR_B_66 (CR_B<<8)|0x66
#define CR_B_67 (CR_B<<8)|0x67
#define CR_B_68 (CR_B<<8)|0x68
#define CR_B_69 (CR_B<<8)|0x69
#define CR_B_6A (CR_B<<8)|0x6A
#define CR_B_6B (CR_B<<8)|0x6B
#define CR_B_6C (CR_B<<8)|0x6C
#define CR_B_6D (CR_B<<8)|0x6D
#define CR_B_6E (CR_B<<8)|0x6E
#define CR_B_6F (CR_B<<8)|0x6F
#define CR_B_70 (CR_B<<8)|0x70
#define CR_B_71 (CR_B<<8)|0x71
#define CR_B_72 (CR_B<<8)|0x72
#define CR_B_73 (CR_B<<8)|0x73
#define CR_B_74 (CR_B<<8)|0x74
#define CR_B_75 (CR_B<<8)|0x75
#define CR_B_76 (CR_B<<8)|0x76
#define CR_B_77 (CR_B<<8)|0x77
#define CR_B_78 (CR_B<<8)|0x78
#define CR_B_79 (CR_B<<8)|0x79
#define CR_B_7A (CR_B<<8)|0x7A
#define CR_B_7B (CR_B<<8)|0x7B
#define CR_B_7C (CR_B<<8)|0x7C
#define CR_B_7D (CR_B<<8)|0x7D
#define CR_B_7E (CR_B<<8)|0x7E
#define CR_B_7F (CR_B<<8)|0x7F
#define CR_B_80 (CR_B<<8)|0x80
#define CR_B_81 (CR_B<<8)|0x81
#define CR_B_82 (CR_B<<8)|0x82
#define CR_B_83 (CR_B<<8)|0x83
#define CR_B_84 (CR_B<<8)|0x84
#define CR_B_85 (CR_B<<8)|0x85
#define CR_B_86 (CR_B<<8)|0x86
#define CR_B_87 (CR_B<<8)|0x87
#define CR_B_88 (CR_B<<8)|0x88
#define CR_B_89 (CR_B<<8)|0x89
#define CR_B_8A (CR_B<<8)|0x8A
#define CR_B_8B (CR_B<<8)|0x8B
#define CR_B_8C (CR_B<<8)|0x8C
#define CR_B_8D (CR_B<<8)|0x8D
#define CR_B_8E (CR_B<<8)|0x8E
#define CR_B_8F (CR_B<<8)|0x8F
#define CR_B_90 (CR_B<<8)|0x90
#define CR_B_91 (CR_B<<8)|0x91
#define CR_B_92 (CR_B<<8)|0x92
#define CR_B_93 (CR_B<<8)|0x93
#define CR_B_94 (CR_B<<8)|0x94
#define CR_B_95 (CR_B<<8)|0x95
#define CR_B_96 (CR_B<<8)|0x96
#define CR_B_97 (CR_B<<8)|0x97
#define CR_B_98 (CR_B<<8)|0x98
#define CR_B_99 (CR_B<<8)|0x99
#define CR_B_9A (CR_B<<8)|0x9A
#define CR_B_9B (CR_B<<8)|0x9B
#define CR_B_9C (CR_B<<8)|0x9C
#define CR_B_9D (CR_B<<8)|0x9D
#define CR_B_9E (CR_B<<8)|0x9E
#define CR_B_9F (CR_B<<8)|0x9F
#define CR_B_A0 (CR_B<<8)|0xA0
#define CR_B_A1 (CR_B<<8)|0xA1
#define CR_B_A2 (CR_B<<8)|0xA2
#define CR_B_A3 (CR_B<<8)|0xA3
#define CR_B_A4 (CR_B<<8)|0xA4
#define CR_B_A5 (CR_B<<8)|0xA5
#define CR_B_A6 (CR_B<<8)|0xA6
#define CR_B_A7 (CR_B<<8)|0xA7
#define CR_B_A8 (CR_B<<8)|0xA8
#define CR_B_A9 (CR_B<<8)|0xA9
#define CR_B_AA (CR_B<<8)|0xAA
#define CR_B_AB (CR_B<<8)|0xAB
#define CR_B_AC (CR_B<<8)|0xAC
#define CR_B_AD (CR_B<<8)|0xAD
#define CR_B_AE (CR_B<<8)|0xAE
#define CR_B_AF (CR_B<<8)|0xAF
#define CR_B_B0 (CR_B<<8)|0xB0
#define CR_B_B1 (CR_B<<8)|0xB1
#define CR_B_B2 (CR_B<<8)|0xB2
#define CR_B_B3 (CR_B<<8)|0xB3
#define CR_B_B4 (CR_B<<8)|0xB4
#define CR_B_B5 (CR_B<<8)|0xB5
#define CR_B_B6 (CR_B<<8)|0xB6
#define CR_B_B7 (CR_B<<8)|0xB7
#define CR_B_B8 (CR_B<<8)|0xB8
#define CR_B_B9 (CR_B<<8)|0xB9
#define CR_B_BA (CR_B<<8)|0xBA
#define CR_B_BB (CR_B<<8)|0xBB
#define CR_B_BC (CR_B<<8)|0xBC
#define CR_B_BD (CR_B<<8)|0xBD
#define CR_B_BE (CR_B<<8)|0xBE
#define CR_B_BF (CR_B<<8)|0xBF
#define CR_B_C0 (CR_B<<8)|0xC0
#define CR_B_C1 (CR_B<<8)|0xC1
#define CR_B_C2 (CR_B<<8)|0xC2
#define CR_B_C3 (CR_B<<8)|0xC3
#define CR_B_C4 (CR_B<<8)|0xC4
#define CR_B_C5 (CR_B<<8)|0xC5
#define CR_B_C6 (CR_B<<8)|0xC6
#define CR_B_C7 (CR_B<<8)|0xC7
#define CR_B_C8 (CR_B<<8)|0xC8
#define CR_B_C9 (CR_B<<8)|0xC9
#define CR_B_CA (CR_B<<8)|0xCA
#define CR_B_CB (CR_B<<8)|0xCB
#define CR_B_CC (CR_B<<8)|0xCC
#define CR_B_CD (CR_B<<8)|0xCD
#define CR_B_CE (CR_B<<8)|0xCE
#define CR_B_CF (CR_B<<8)|0xCF
#define CR_B_D0 (CR_B<<8)|0xD0
#define CR_B_D1 (CR_B<<8)|0xD1
#define CR_B_D2 (CR_B<<8)|0xD2
#define CR_B_D3 (CR_B<<8)|0xD3
#define CR_B_D4 (CR_B<<8)|0xD4
#define CR_B_D5 (CR_B<<8)|0xD5
#define CR_B_D6 (CR_B<<8)|0xD6
#define CR_B_D7 (CR_B<<8)|0xD7
#define CR_B_D8 (CR_B<<8)|0xD8
#define CR_B_D9 (CR_B<<8)|0xD9
#define CR_B_DA (CR_B<<8)|0xDA
#define CR_B_DB (CR_B<<8)|0xDB
#define CR_B_DC (CR_B<<8)|0xDC
#define CR_B_DD (CR_B<<8)|0xDD
#define CR_B_DE (CR_B<<8)|0xDE
#define CR_B_DF (CR_B<<8)|0xDF
#define CR_B_E0 (CR_B<<8)|0xE0
#define CR_B_E1 (CR_B<<8)|0xE1
#define CR_B_E2 (CR_B<<8)|0xE2
#define CR_B_E3 (CR_B<<8)|0xE3
#define CR_B_E4 (CR_B<<8)|0xE4
#define CR_B_E5 (CR_B<<8)|0xE5
#define CR_B_E6 (CR_B<<8)|0xE6
#define CR_B_E7 (CR_B<<8)|0xE7
#define CR_B_E8 (CR_B<<8)|0xE8
#define CR_B_E9 (CR_B<<8)|0xE9
#define CR_B_EA (CR_B<<8)|0xEA
#define CR_B_EB (CR_B<<8)|0xEB
#define CR_B_EC (CR_B<<8)|0xEC
#define CR_B_ED (CR_B<<8)|0xED
#define CR_B_EE (CR_B<<8)|0xEE
#define CR_B_EF (CR_B<<8)|0xEF
#define CR_B_F0 (CR_B<<8)|0xF0
#define CR_B_F1 (CR_B<<8)|0xF1
#define CR_B_F2 (CR_B<<8)|0xF2
#define CR_B_F3 (CR_B<<8)|0xF3
#define CR_B_F4 (CR_B<<8)|0xF4
#define CR_B_F5 (CR_B<<8)|0xF5
#define CR_B_F6 (CR_B<<8)|0xF6
#define CR_B_F7 (CR_B<<8)|0xF7
#define CR_B_F8 (CR_B<<8)|0xF8
#define CR_B_F9 (CR_B<<8)|0xF9
#define CR_B_FA (CR_B<<8)|0xFA
#define CR_B_FB (CR_B<<8)|0xFB
#define CR_B_FC (CR_B<<8)|0xFC
#define CR_B_FD (CR_B<<8)|0xFD
#define CR_B_FE (CR_B<<8)|0xFE
#define CR_B_FF (CR_B<<8)|0xFF

#define SR_B_00 (SR_B<<8)|0x00
#define SR_B_01 (SR_B<<8)|0x01
#define SR_B_02 (SR_B<<8)|0x02
#define SR_B_03 (SR_B<<8)|0x03
#define SR_B_04 (SR_B<<8)|0x04
#define SR_B_05 (SR_B<<8)|0x05
#define SR_B_06 (SR_B<<8)|0x06
#define SR_B_07 (SR_B<<8)|0x07
#define SR_B_08 (SR_B<<8)|0x08
#define SR_B_09 (SR_B<<8)|0x09
#define SR_B_0A (SR_B<<8)|0x0A
#define SR_B_0B (SR_B<<8)|0x0B
#define SR_B_0C (SR_B<<8)|0x0C
#define SR_B_0D (SR_B<<8)|0x0D
#define SR_B_0E (SR_B<<8)|0x0E
#define SR_B_0F (SR_B<<8)|0x0F
#define SR_B_10 (SR_B<<8)|0x10
#define SR_B_11 (SR_B<<8)|0x11
#define SR_B_12 (SR_B<<8)|0x12
#define SR_B_13 (SR_B<<8)|0x13
#define SR_B_14 (SR_B<<8)|0x14
#define SR_B_15 (SR_B<<8)|0x15
#define SR_B_16 (SR_B<<8)|0x16
#define SR_B_17 (SR_B<<8)|0x17
#define SR_B_18 (SR_B<<8)|0x18
#define SR_B_19 (SR_B<<8)|0x19
#define SR_B_1A (SR_B<<8)|0x1A
#define SR_B_1B (SR_B<<8)|0x1B
#define SR_B_1C (SR_B<<8)|0x1C
#define SR_B_1D (SR_B<<8)|0x1D
#define SR_B_1E (SR_B<<8)|0x1E
#define SR_B_1F (SR_B<<8)|0x1F
#define SR_B_20 (SR_B<<8)|0x20
#define SR_B_21 (SR_B<<8)|0x21
#define SR_B_22 (SR_B<<8)|0x22
#define SR_B_23 (SR_B<<8)|0x23
#define SR_B_24 (SR_B<<8)|0x24
#define SR_B_25 (SR_B<<8)|0x25
#define SR_B_26 (SR_B<<8)|0x26
#define SR_B_27 (SR_B<<8)|0x27
#define SR_B_28 (SR_B<<8)|0x28
#define SR_B_29 (SR_B<<8)|0x29
#define SR_B_2A (SR_B<<8)|0x2A
#define SR_B_2B (SR_B<<8)|0x2B
#define SR_B_2C (SR_B<<8)|0x2C
#define SR_B_2D (SR_B<<8)|0x2D
#define SR_B_2E (SR_B<<8)|0x2E
#define SR_B_2F (SR_B<<8)|0x2F
#define SR_B_30 (SR_B<<8)|0x30
#define SR_B_31 (SR_B<<8)|0x31
#define SR_B_32 (SR_B<<8)|0x32
#define SR_B_33 (SR_B<<8)|0x33
#define SR_B_34 (SR_B<<8)|0x34
#define SR_B_35 (SR_B<<8)|0x35
#define SR_B_36 (SR_B<<8)|0x36
#define SR_B_37 (SR_B<<8)|0x37
#define SR_B_38 (SR_B<<8)|0x38
#define SR_B_39 (SR_B<<8)|0x39
#define SR_B_3A (SR_B<<8)|0x3A
#define SR_B_3B (SR_B<<8)|0x3B
#define SR_B_3C (SR_B<<8)|0x3C
#define SR_B_3D (SR_B<<8)|0x3D
#define SR_B_3E (SR_B<<8)|0x3E
#define SR_B_3F (SR_B<<8)|0x3F
#define SR_B_40 (SR_B<<8)|0x40
#define SR_B_41 (SR_B<<8)|0x41
#define SR_B_42 (SR_B<<8)|0x42
#define SR_B_43 (SR_B<<8)|0x43
#define SR_B_44 (SR_B<<8)|0x44
#define SR_B_45 (SR_B<<8)|0x45
#define SR_B_46 (SR_B<<8)|0x46
#define SR_B_47 (SR_B<<8)|0x47
#define SR_B_48 (SR_B<<8)|0x48
#define SR_B_49 (SR_B<<8)|0x49
#define SR_B_4A (SR_B<<8)|0x4A
#define SR_B_4B (SR_B<<8)|0x4B
#define SR_B_4C (SR_B<<8)|0x4C
#define SR_B_4D (SR_B<<8)|0x4D
#define SR_B_4E (SR_B<<8)|0x4E
#define SR_B_4F (SR_B<<8)|0x4F
#define SR_B_50 (SR_B<<8)|0x50
#define SR_B_51 (SR_B<<8)|0x51
#define SR_B_52 (SR_B<<8)|0x52
#define SR_B_53 (SR_B<<8)|0x53
#define SR_B_54 (SR_B<<8)|0x54
#define SR_B_55 (SR_B<<8)|0x55
#define SR_B_56 (SR_B<<8)|0x56
#define SR_B_57 (SR_B<<8)|0x57
#define SR_B_58 (SR_B<<8)|0x58
#define SR_B_59 (SR_B<<8)|0x59
#define SR_B_5A (SR_B<<8)|0x5A
#define SR_B_5B (SR_B<<8)|0x5B
#define SR_B_5C (SR_B<<8)|0x5C
#define SR_B_5D (SR_B<<8)|0x5D
#define SR_B_5E (SR_B<<8)|0x5E
#define SR_B_5F (SR_B<<8)|0x5F
#define SR_B_60 (SR_B<<8)|0x60
#define SR_B_61 (SR_B<<8)|0x61
#define SR_B_62 (SR_B<<8)|0x62
#define SR_B_63 (SR_B<<8)|0x63
#define SR_B_64 (SR_B<<8)|0x64
#define SR_B_65 (SR_B<<8)|0x65
#define SR_B_66 (SR_B<<8)|0x66
#define SR_B_67 (SR_B<<8)|0x67
#define SR_B_68 (SR_B<<8)|0x68
#define SR_B_69 (SR_B<<8)|0x69
#define SR_B_6A (SR_B<<8)|0x6A
#define SR_B_6B (SR_B<<8)|0x6B
#define SR_B_6C (SR_B<<8)|0x6C
#define SR_B_6D (SR_B<<8)|0x6D
#define SR_B_6E (SR_B<<8)|0x6E
#define SR_B_6F (SR_B<<8)|0x6F
#define SR_B_70 (SR_B<<8)|0x70
#define SR_B_71 (SR_B<<8)|0x71
#define SR_B_72 (SR_B<<8)|0x72
#define SR_B_73 (SR_B<<8)|0x73
#define SR_B_74 (SR_B<<8)|0x74
#define SR_B_75 (SR_B<<8)|0x75
#define SR_B_76 (SR_B<<8)|0x76
#define SR_B_77 (SR_B<<8)|0x77
#define SR_B_78 (SR_B<<8)|0x78
#define SR_B_79 (SR_B<<8)|0x79
#define SR_B_7A (SR_B<<8)|0x7A
#define SR_B_7B (SR_B<<8)|0x7B
#define SR_B_7C (SR_B<<8)|0x7C
#define SR_B_7D (SR_B<<8)|0x7D
#define SR_B_7E (SR_B<<8)|0x7E
#define SR_B_7F (SR_B<<8)|0x7F
#define SR_B_80 (SR_B<<8)|0x80
#define SR_B_81 (SR_B<<8)|0x81
#define SR_B_82 (SR_B<<8)|0x82
#define SR_B_83 (SR_B<<8)|0x83
#define SR_B_84 (SR_B<<8)|0x84
#define SR_B_85 (SR_B<<8)|0x85
#define SR_B_86 (SR_B<<8)|0x86
#define SR_B_87 (SR_B<<8)|0x87
#define SR_B_88 (SR_B<<8)|0x88
#define SR_B_89 (SR_B<<8)|0x89
#define SR_B_8A (SR_B<<8)|0x8A
#define SR_B_8B (SR_B<<8)|0x8B
#define SR_B_8C (SR_B<<8)|0x8C
#define SR_B_8D (SR_B<<8)|0x8D
#define SR_B_8E (SR_B<<8)|0x8E
#define SR_B_8F (SR_B<<8)|0x8F
#define SR_B_90 (SR_B<<8)|0x90
#define SR_B_91 (SR_B<<8)|0x91
#define SR_B_92 (SR_B<<8)|0x92
#define SR_B_93 (SR_B<<8)|0x93
#define SR_B_94 (SR_B<<8)|0x94
#define SR_B_95 (SR_B<<8)|0x95
#define SR_B_96 (SR_B<<8)|0x96
#define SR_B_97 (SR_B<<8)|0x97
#define SR_B_98 (SR_B<<8)|0x98
#define SR_B_99 (SR_B<<8)|0x99
#define SR_B_9A (SR_B<<8)|0x9A
#define SR_B_9B (SR_B<<8)|0x9B
#define SR_B_9C (SR_B<<8)|0x9C
#define SR_B_9D (SR_B<<8)|0x9D
#define SR_B_9E (SR_B<<8)|0x9E
#define SR_B_9F (SR_B<<8)|0x9F
#define SR_B_A0 (SR_B<<8)|0xA0
#define SR_B_A1 (SR_B<<8)|0xA1
#define SR_B_A2 (SR_B<<8)|0xA2
#define SR_B_A3 (SR_B<<8)|0xA3
#define SR_B_A4 (SR_B<<8)|0xA4
#define SR_B_A5 (SR_B<<8)|0xA5
#define SR_B_A6 (SR_B<<8)|0xA6
#define SR_B_A7 (SR_B<<8)|0xA7
#define SR_B_A8 (SR_B<<8)|0xA8
#define SR_B_A9 (SR_B<<8)|0xA9
#define SR_B_AA (SR_B<<8)|0xAA
#define SR_B_AB (SR_B<<8)|0xAB
#define SR_B_AC (SR_B<<8)|0xAC
#define SR_B_AD (SR_B<<8)|0xAD
#define SR_B_AE (SR_B<<8)|0xAE
#define SR_B_AF (SR_B<<8)|0xAF
#define SR_B_B0 (SR_B<<8)|0xB0
#define SR_B_B1 (SR_B<<8)|0xB1
#define SR_B_B2 (SR_B<<8)|0xB2
#define SR_B_B3 (SR_B<<8)|0xB3
#define SR_B_B4 (SR_B<<8)|0xB4
#define SR_B_B5 (SR_B<<8)|0xB5
#define SR_B_B6 (SR_B<<8)|0xB6
#define SR_B_B7 (SR_B<<8)|0xB7
#define SR_B_B8 (SR_B<<8)|0xB8
#define SR_B_B9 (SR_B<<8)|0xB9
#define SR_B_BA (SR_B<<8)|0xBA
#define SR_B_BB (SR_B<<8)|0xBB
#define SR_B_BC (SR_B<<8)|0xBC
#define SR_B_BD (SR_B<<8)|0xBD
#define SR_B_BE (SR_B<<8)|0xBE
#define SR_B_BF (SR_B<<8)|0xBF
#define SR_B_C0 (SR_B<<8)|0xC0
#define SR_B_C1 (SR_B<<8)|0xC1
#define SR_B_C2 (SR_B<<8)|0xC2
#define SR_B_C3 (SR_B<<8)|0xC3
#define SR_B_C4 (SR_B<<8)|0xC4
#define SR_B_C5 (SR_B<<8)|0xC5
#define SR_B_C6 (SR_B<<8)|0xC6
#define SR_B_C7 (SR_B<<8)|0xC7
#define SR_B_C8 (SR_B<<8)|0xC8
#define SR_B_C9 (SR_B<<8)|0xC9
#define SR_B_CA (SR_B<<8)|0xCA
#define SR_B_CB (SR_B<<8)|0xCB
#define SR_B_CC (SR_B<<8)|0xCC
#define SR_B_CD (SR_B<<8)|0xCD
#define SR_B_CE (SR_B<<8)|0xCE
#define SR_B_CF (SR_B<<8)|0xCF
#define SR_B_D0 (SR_B<<8)|0xD0
#define SR_B_D1 (SR_B<<8)|0xD1
#define SR_B_D2 (SR_B<<8)|0xD2
#define SR_B_D3 (SR_B<<8)|0xD3
#define SR_B_D4 (SR_B<<8)|0xD4
#define SR_B_D5 (SR_B<<8)|0xD5
#define SR_B_D6 (SR_B<<8)|0xD6
#define SR_B_D7 (SR_B<<8)|0xD7
#define SR_B_D8 (SR_B<<8)|0xD8
#define SR_B_D9 (SR_B<<8)|0xD9
#define SR_B_DA (SR_B<<8)|0xDA
#define SR_B_DB (SR_B<<8)|0xDB
#define SR_B_DC (SR_B<<8)|0xDC
#define SR_B_DD (SR_B<<8)|0xDD
#define SR_B_DE (SR_B<<8)|0xDE
#define SR_B_DF (SR_B<<8)|0xDF
#define SR_B_E0 (SR_B<<8)|0xE0
#define SR_B_E1 (SR_B<<8)|0xE1
#define SR_B_E2 (SR_B<<8)|0xE2
#define SR_B_E3 (SR_B<<8)|0xE3
#define SR_B_E4 (SR_B<<8)|0xE4
#define SR_B_E5 (SR_B<<8)|0xE5
#define SR_B_E6 (SR_B<<8)|0xE6
#define SR_B_E7 (SR_B<<8)|0xE7
#define SR_B_E8 (SR_B<<8)|0xE8
#define SR_B_E9 (SR_B<<8)|0xE9
#define SR_B_EA (SR_B<<8)|0xEA
#define SR_B_EB (SR_B<<8)|0xEB
#define SR_B_EC (SR_B<<8)|0xEC
#define SR_B_ED (SR_B<<8)|0xED
#define SR_B_EE (SR_B<<8)|0xEE
#define SR_B_EF (SR_B<<8)|0xEF
#define SR_B_F0 (SR_B<<8)|0xF0
#define SR_B_F1 (SR_B<<8)|0xF1
#define SR_B_F2 (SR_B<<8)|0xF2
#define SR_B_F3 (SR_B<<8)|0xF3
#define SR_B_F4 (SR_B<<8)|0xF4
#define SR_B_F5 (SR_B<<8)|0xF5
#define SR_B_F6 (SR_B<<8)|0xF6
#define SR_B_F7 (SR_B<<8)|0xF7
#define SR_B_F8 (SR_B<<8)|0xF8
#define SR_B_F9 (SR_B<<8)|0xF9
#define SR_B_FA (SR_B<<8)|0xFA
#define SR_B_FB (SR_B<<8)|0xFB
#define SR_B_FC (SR_B<<8)|0xFC
#define SR_B_FD (SR_B<<8)|0xFD
#define SR_B_FE (SR_B<<8)|0xFE
#define SR_B_FF (SR_B<<8)|0xFF

#define CR_D_00 (CR_D<<8)|0x00
#define CR_D_01 (CR_D<<8)|0x01
#define CR_D_02 (CR_D<<8)|0x02
#define CR_D_03 (CR_D<<8)|0x03
#define CR_D_04 (CR_D<<8)|0x04
#define CR_D_05 (CR_D<<8)|0x05
#define CR_D_06 (CR_D<<8)|0x06
#define CR_D_07 (CR_D<<8)|0x07
#define CR_D_08 (CR_D<<8)|0x08
#define CR_D_09 (CR_D<<8)|0x09
#define CR_D_0A (CR_D<<8)|0x0A
#define CR_D_0B (CR_D<<8)|0x0B
#define CR_D_0C (CR_D<<8)|0x0C
#define CR_D_0D (CR_D<<8)|0x0D
#define CR_D_0E (CR_D<<8)|0x0E
#define CR_D_0F (CR_D<<8)|0x0F
#define CR_D_10 (CR_D<<8)|0x10
#define CR_D_11 (CR_D<<8)|0x11
#define CR_D_12 (CR_D<<8)|0x12
#define CR_D_13 (CR_D<<8)|0x13
#define CR_D_14 (CR_D<<8)|0x14
#define CR_D_15 (CR_D<<8)|0x15
#define CR_D_16 (CR_D<<8)|0x16
#define CR_D_17 (CR_D<<8)|0x17
#define CR_D_18 (CR_D<<8)|0x18
#define CR_D_19 (CR_D<<8)|0x19
#define CR_D_1A (CR_D<<8)|0x1A
#define CR_D_1B (CR_D<<8)|0x1B
#define CR_D_1C (CR_D<<8)|0x1C
#define CR_D_1D (CR_D<<8)|0x1D
#define CR_D_1E (CR_D<<8)|0x1E
#define CR_D_1F (CR_D<<8)|0x1F
#define CR_D_20 (CR_D<<8)|0x20
#define CR_D_21 (CR_D<<8)|0x21
#define CR_D_22 (CR_D<<8)|0x22
#define CR_D_23 (CR_D<<8)|0x23
#define CR_D_24 (CR_D<<8)|0x24
#define CR_D_25 (CR_D<<8)|0x25
#define CR_D_26 (CR_D<<8)|0x26
#define CR_D_27 (CR_D<<8)|0x27
#define CR_D_28 (CR_D<<8)|0x28
#define CR_D_29 (CR_D<<8)|0x29
#define CR_D_2A (CR_D<<8)|0x2A
#define CR_D_2B (CR_D<<8)|0x2B
#define CR_D_2C (CR_D<<8)|0x2C
#define CR_D_2D (CR_D<<8)|0x2D
#define CR_D_2E (CR_D<<8)|0x2E
#define CR_D_2F (CR_D<<8)|0x2F
#define CR_D_30 (CR_D<<8)|0x30
#define CR_D_31 (CR_D<<8)|0x31
#define CR_D_32 (CR_D<<8)|0x32
#define CR_D_33 (CR_D<<8)|0x33
#define CR_D_34 (CR_D<<8)|0x34
#define CR_D_35 (CR_D<<8)|0x35
#define CR_D_36 (CR_D<<8)|0x36
#define CR_D_37 (CR_D<<8)|0x37
#define CR_D_38 (CR_D<<8)|0x38
#define CR_D_39 (CR_D<<8)|0x39
#define CR_D_3A (CR_D<<8)|0x3A
#define CR_D_3B (CR_D<<8)|0x3B
#define CR_D_3C (CR_D<<8)|0x3C
#define CR_D_3D (CR_D<<8)|0x3D
#define CR_D_3E (CR_D<<8)|0x3E
#define CR_D_3F (CR_D<<8)|0x3F
#define CR_D_40 (CR_D<<8)|0x40
#define CR_D_41 (CR_D<<8)|0x41
#define CR_D_42 (CR_D<<8)|0x42
#define CR_D_43 (CR_D<<8)|0x43
#define CR_D_44 (CR_D<<8)|0x44
#define CR_D_45 (CR_D<<8)|0x45
#define CR_D_46 (CR_D<<8)|0x46
#define CR_D_47 (CR_D<<8)|0x47
#define CR_D_48 (CR_D<<8)|0x48
#define CR_D_49 (CR_D<<8)|0x49
#define CR_D_4A (CR_D<<8)|0x4A
#define CR_D_4B (CR_D<<8)|0x4B
#define CR_D_4C (CR_D<<8)|0x4C
#define CR_D_4D (CR_D<<8)|0x4D
#define CR_D_4E (CR_D<<8)|0x4E
#define CR_D_4F (CR_D<<8)|0x4F
#define CR_D_50 (CR_D<<8)|0x50
#define CR_D_51 (CR_D<<8)|0x51
#define CR_D_52 (CR_D<<8)|0x52
#define CR_D_53 (CR_D<<8)|0x53
#define CR_D_54 (CR_D<<8)|0x54
#define CR_D_55 (CR_D<<8)|0x55
#define CR_D_56 (CR_D<<8)|0x56
#define CR_D_57 (CR_D<<8)|0x57
#define CR_D_58 (CR_D<<8)|0x58
#define CR_D_59 (CR_D<<8)|0x59
#define CR_D_5A (CR_D<<8)|0x5A
#define CR_D_5B (CR_D<<8)|0x5B
#define CR_D_5C (CR_D<<8)|0x5C
#define CR_D_5D (CR_D<<8)|0x5D
#define CR_D_5E (CR_D<<8)|0x5E
#define CR_D_5F (CR_D<<8)|0x5F
#define CR_D_60 (CR_D<<8)|0x60
#define CR_D_61 (CR_D<<8)|0x61
#define CR_D_62 (CR_D<<8)|0x62
#define CR_D_63 (CR_D<<8)|0x63
#define CR_D_64 (CR_D<<8)|0x64
#define CR_D_65 (CR_D<<8)|0x65
#define CR_D_66 (CR_D<<8)|0x66
#define CR_D_67 (CR_D<<8)|0x67
#define CR_D_68 (CR_D<<8)|0x68
#define CR_D_69 (CR_D<<8)|0x69
#define CR_D_6A (CR_D<<8)|0x6A
#define CR_D_6B (CR_D<<8)|0x6B
#define CR_D_6C (CR_D<<8)|0x6C
#define CR_D_6D (CR_D<<8)|0x6D
#define CR_D_6E (CR_D<<8)|0x6E
#define CR_D_6F (CR_D<<8)|0x6F
#define CR_D_70 (CR_D<<8)|0x70
#define CR_D_71 (CR_D<<8)|0x71
#define CR_D_72 (CR_D<<8)|0x72
#define CR_D_73 (CR_D<<8)|0x73
#define CR_D_74 (CR_D<<8)|0x74
#define CR_D_75 (CR_D<<8)|0x75
#define CR_D_76 (CR_D<<8)|0x76
#define CR_D_77 (CR_D<<8)|0x77
#define CR_D_78 (CR_D<<8)|0x78
#define CR_D_79 (CR_D<<8)|0x79
#define CR_D_7A (CR_D<<8)|0x7A
#define CR_D_7B (CR_D<<8)|0x7B
#define CR_D_7C (CR_D<<8)|0x7C
#define CR_D_7D (CR_D<<8)|0x7D
#define CR_D_7E (CR_D<<8)|0x7E
#define CR_D_7F (CR_D<<8)|0x7F
#define CR_D_80 (CR_D<<8)|0x80
#define CR_D_81 (CR_D<<8)|0x81
#define CR_D_82 (CR_D<<8)|0x82
#define CR_D_83 (CR_D<<8)|0x83
#define CR_D_84 (CR_D<<8)|0x84
#define CR_D_85 (CR_D<<8)|0x85
#define CR_D_86 (CR_D<<8)|0x86
#define CR_D_87 (CR_D<<8)|0x87
#define CR_D_88 (CR_D<<8)|0x88
#define CR_D_89 (CR_D<<8)|0x89
#define CR_D_8A (CR_D<<8)|0x8A
#define CR_D_8B (CR_D<<8)|0x8B
#define CR_D_8C (CR_D<<8)|0x8C
#define CR_D_8D (CR_D<<8)|0x8D
#define CR_D_8E (CR_D<<8)|0x8E
#define CR_D_8F (CR_D<<8)|0x8F
#define CR_D_90 (CR_D<<8)|0x90
#define CR_D_91 (CR_D<<8)|0x91
#define CR_D_92 (CR_D<<8)|0x92
#define CR_D_93 (CR_D<<8)|0x93
#define CR_D_94 (CR_D<<8)|0x94
#define CR_D_95 (CR_D<<8)|0x95
#define CR_D_96 (CR_D<<8)|0x96
#define CR_D_97 (CR_D<<8)|0x97
#define CR_D_98 (CR_D<<8)|0x98
#define CR_D_99 (CR_D<<8)|0x99
#define CR_D_9A (CR_D<<8)|0x9A
#define CR_D_9B (CR_D<<8)|0x9B
#define CR_D_9C (CR_D<<8)|0x9C
#define CR_D_9D (CR_D<<8)|0x9D
#define CR_D_9E (CR_D<<8)|0x9E
#define CR_D_9F (CR_D<<8)|0x9F
#define CR_D_A0 (CR_D<<8)|0xA0
#define CR_D_A1 (CR_D<<8)|0xA1
#define CR_D_A2 (CR_D<<8)|0xA2
#define CR_D_A3 (CR_D<<8)|0xA3
#define CR_D_A4 (CR_D<<8)|0xA4
#define CR_D_A5 (CR_D<<8)|0xA5
#define CR_D_A6 (CR_D<<8)|0xA6
#define CR_D_A7 (CR_D<<8)|0xA7
#define CR_D_A8 (CR_D<<8)|0xA8
#define CR_D_A9 (CR_D<<8)|0xA9
#define CR_D_AA (CR_D<<8)|0xAA
#define CR_D_AB (CR_D<<8)|0xAB
#define CR_D_AC (CR_D<<8)|0xAC
#define CR_D_AD (CR_D<<8)|0xAD
#define CR_D_AE (CR_D<<8)|0xAE
#define CR_D_AF (CR_D<<8)|0xAF
#define CR_D_B0 (CR_D<<8)|0xB0
#define CR_D_B1 (CR_D<<8)|0xB1
#define CR_D_B2 (CR_D<<8)|0xB2
#define CR_D_B3 (CR_D<<8)|0xB3
#define CR_D_B4 (CR_D<<8)|0xB4
#define CR_D_B5 (CR_D<<8)|0xB5
#define CR_D_B6 (CR_D<<8)|0xB6
#define CR_D_B7 (CR_D<<8)|0xB7
#define CR_D_B8 (CR_D<<8)|0xB8
#define CR_D_B9 (CR_D<<8)|0xB9
#define CR_D_BA (CR_D<<8)|0xBA
#define CR_D_BB (CR_D<<8)|0xBB
#define CR_D_BC (CR_D<<8)|0xBC
#define CR_D_BD (CR_D<<8)|0xBD
#define CR_D_BE (CR_D<<8)|0xBE
#define CR_D_BF (CR_D<<8)|0xBF
#define CR_D_C0 (CR_D<<8)|0xC0
#define CR_D_C1 (CR_D<<8)|0xC1
#define CR_D_C2 (CR_D<<8)|0xC2
#define CR_D_C3 (CR_D<<8)|0xC3
#define CR_D_C4 (CR_D<<8)|0xC4
#define CR_D_C5 (CR_D<<8)|0xC5
#define CR_D_C6 (CR_D<<8)|0xC6
#define CR_D_C7 (CR_D<<8)|0xC7
#define CR_D_C8 (CR_D<<8)|0xC8
#define CR_D_C9 (CR_D<<8)|0xC9
#define CR_D_CA (CR_D<<8)|0xCA
#define CR_D_CB (CR_D<<8)|0xCB
#define CR_D_CC (CR_D<<8)|0xCC
#define CR_D_CD (CR_D<<8)|0xCD
#define CR_D_CE (CR_D<<8)|0xCE
#define CR_D_CF (CR_D<<8)|0xCF
#define CR_D_D0 (CR_D<<8)|0xD0
#define CR_D_D1 (CR_D<<8)|0xD1
#define CR_D_D2 (CR_D<<8)|0xD2
#define CR_D_D3 (CR_D<<8)|0xD3
#define CR_D_D4 (CR_D<<8)|0xD4
#define CR_D_D5 (CR_D<<8)|0xD5
#define CR_D_D6 (CR_D<<8)|0xD6
#define CR_D_D7 (CR_D<<8)|0xD7
#define CR_D_D8 (CR_D<<8)|0xD8
#define CR_D_D9 (CR_D<<8)|0xD9
#define CR_D_DA (CR_D<<8)|0xDA
#define CR_D_DB (CR_D<<8)|0xDB
#define CR_D_DC (CR_D<<8)|0xDC
#define CR_D_DD (CR_D<<8)|0xDD
#define CR_D_DE (CR_D<<8)|0xDE
#define CR_D_DF (CR_D<<8)|0xDF
#define CR_D_E0 (CR_D<<8)|0xE0
#define CR_D_E1 (CR_D<<8)|0xE1
#define CR_D_E2 (CR_D<<8)|0xE2
#define CR_D_E3 (CR_D<<8)|0xE3
#define CR_D_E4 (CR_D<<8)|0xE4
#define CR_D_E5 (CR_D<<8)|0xE5
#define CR_D_E6 (CR_D<<8)|0xE6
#define CR_D_E7 (CR_D<<8)|0xE7
#define CR_D_E8 (CR_D<<8)|0xE8
#define CR_D_E9 (CR_D<<8)|0xE9
#define CR_D_EA (CR_D<<8)|0xEA
#define CR_D_EB (CR_D<<8)|0xEB
#define CR_D_EC (CR_D<<8)|0xEC
#define CR_D_ED (CR_D<<8)|0xED
#define CR_D_EE (CR_D<<8)|0xEE
#define CR_D_EF (CR_D<<8)|0xEF
#define CR_D_F0 (CR_D<<8)|0xF0
#define CR_D_F1 (CR_D<<8)|0xF1
#define CR_D_F2 (CR_D<<8)|0xF2
#define CR_D_F3 (CR_D<<8)|0xF3
#define CR_D_F4 (CR_D<<8)|0xF4
#define CR_D_F5 (CR_D<<8)|0xF5
#define CR_D_F6 (CR_D<<8)|0xF6
#define CR_D_F7 (CR_D<<8)|0xF7
#define CR_D_F8 (CR_D<<8)|0xF8
#define CR_D_F9 (CR_D<<8)|0xF9
#define CR_D_FA (CR_D<<8)|0xFA
#define CR_D_FB (CR_D<<8)|0xFB
#define CR_D_FC (CR_D<<8)|0xFC
#define CR_D_FD (CR_D<<8)|0xFD
#define CR_D_FE (CR_D<<8)|0xFE
#define CR_D_FF (CR_D<<8)|0xFF

#define CR_T_00 (CR_T<<8)|0x00
#define CR_T_01 (CR_T<<8)|0x01
#define CR_T_02 (CR_T<<8)|0x02
#define CR_T_03 (CR_T<<8)|0x03
#define CR_T_04 (CR_T<<8)|0x04
#define CR_T_05 (CR_T<<8)|0x05
#define CR_T_06 (CR_T<<8)|0x06
#define CR_T_07 (CR_T<<8)|0x07
#define CR_T_08 (CR_T<<8)|0x08
#define CR_T_09 (CR_T<<8)|0x09
#define CR_T_0A (CR_T<<8)|0x0A
#define CR_T_0B (CR_T<<8)|0x0B
#define CR_T_0C (CR_T<<8)|0x0C
#define CR_T_0D (CR_T<<8)|0x0D
#define CR_T_0E (CR_T<<8)|0x0E
#define CR_T_0F (CR_T<<8)|0x0F
#define CR_T_10 (CR_T<<8)|0x10
#define CR_T_11 (CR_T<<8)|0x11
#define CR_T_12 (CR_T<<8)|0x12
#define CR_T_13 (CR_T<<8)|0x13
#define CR_T_14 (CR_T<<8)|0x14
#define CR_T_15 (CR_T<<8)|0x15
#define CR_T_16 (CR_T<<8)|0x16
#define CR_T_17 (CR_T<<8)|0x17
#define CR_T_18 (CR_T<<8)|0x18
#define CR_T_19 (CR_T<<8)|0x19
#define CR_T_1A (CR_T<<8)|0x1A
#define CR_T_1B (CR_T<<8)|0x1B
#define CR_T_1C (CR_T<<8)|0x1C
#define CR_T_1D (CR_T<<8)|0x1D
#define CR_T_1E (CR_T<<8)|0x1E
#define CR_T_1F (CR_T<<8)|0x1F
#define CR_T_20 (CR_T<<8)|0x20
#define CR_T_21 (CR_T<<8)|0x21
#define CR_T_22 (CR_T<<8)|0x22
#define CR_T_23 (CR_T<<8)|0x23
#define CR_T_24 (CR_T<<8)|0x24
#define CR_T_25 (CR_T<<8)|0x25
#define CR_T_26 (CR_T<<8)|0x26
#define CR_T_27 (CR_T<<8)|0x27
#define CR_T_28 (CR_T<<8)|0x28
#define CR_T_29 (CR_T<<8)|0x29
#define CR_T_2A (CR_T<<8)|0x2A
#define CR_T_2B (CR_T<<8)|0x2B
#define CR_T_2C (CR_T<<8)|0x2C
#define CR_T_2D (CR_T<<8)|0x2D
#define CR_T_2E (CR_T<<8)|0x2E
#define CR_T_2F (CR_T<<8)|0x2F
#define CR_T_30 (CR_T<<8)|0x30
#define CR_T_31 (CR_T<<8)|0x31
#define CR_T_32 (CR_T<<8)|0x32
#define CR_T_33 (CR_T<<8)|0x33
#define CR_T_34 (CR_T<<8)|0x34
#define CR_T_35 (CR_T<<8)|0x35
#define CR_T_36 (CR_T<<8)|0x36
#define CR_T_37 (CR_T<<8)|0x37
#define CR_T_38 (CR_T<<8)|0x38
#define CR_T_39 (CR_T<<8)|0x39
#define CR_T_3A (CR_T<<8)|0x3A
#define CR_T_3B (CR_T<<8)|0x3B
#define CR_T_3C (CR_T<<8)|0x3C
#define CR_T_3D (CR_T<<8)|0x3D
#define CR_T_3E (CR_T<<8)|0x3E
#define CR_T_3F (CR_T<<8)|0x3F
#define CR_T_40 (CR_T<<8)|0x40
#define CR_T_41 (CR_T<<8)|0x41
#define CR_T_42 (CR_T<<8)|0x42
#define CR_T_43 (CR_T<<8)|0x43
#define CR_T_44 (CR_T<<8)|0x44
#define CR_T_45 (CR_T<<8)|0x45
#define CR_T_46 (CR_T<<8)|0x46
#define CR_T_47 (CR_T<<8)|0x47
#define CR_T_48 (CR_T<<8)|0x48
#define CR_T_49 (CR_T<<8)|0x49
#define CR_T_4A (CR_T<<8)|0x4A
#define CR_T_4B (CR_T<<8)|0x4B
#define CR_T_4C (CR_T<<8)|0x4C
#define CR_T_4D (CR_T<<8)|0x4D
#define CR_T_4E (CR_T<<8)|0x4E
#define CR_T_4F (CR_T<<8)|0x4F
#define CR_T_50 (CR_T<<8)|0x50
#define CR_T_51 (CR_T<<8)|0x51
#define CR_T_52 (CR_T<<8)|0x52
#define CR_T_53 (CR_T<<8)|0x53
#define CR_T_54 (CR_T<<8)|0x54
#define CR_T_55 (CR_T<<8)|0x55
#define CR_T_56 (CR_T<<8)|0x56
#define CR_T_57 (CR_T<<8)|0x57
#define CR_T_58 (CR_T<<8)|0x58
#define CR_T_59 (CR_T<<8)|0x59
#define CR_T_5A (CR_T<<8)|0x5A
#define CR_T_5B (CR_T<<8)|0x5B
#define CR_T_5C (CR_T<<8)|0x5C
#define CR_T_5D (CR_T<<8)|0x5D
#define CR_T_5E (CR_T<<8)|0x5E
#define CR_T_5F (CR_T<<8)|0x5F
#define CR_T_60 (CR_T<<8)|0x60
#define CR_T_61 (CR_T<<8)|0x61
#define CR_T_62 (CR_T<<8)|0x62
#define CR_T_63 (CR_T<<8)|0x63
#define CR_T_64 (CR_T<<8)|0x64
#define CR_T_65 (CR_T<<8)|0x65
#define CR_T_66 (CR_T<<8)|0x66
#define CR_T_67 (CR_T<<8)|0x67
#define CR_T_68 (CR_T<<8)|0x68
#define CR_T_69 (CR_T<<8)|0x69
#define CR_T_6A (CR_T<<8)|0x6A
#define CR_T_6B (CR_T<<8)|0x6B
#define CR_T_6C (CR_T<<8)|0x6C
#define CR_T_6D (CR_T<<8)|0x6D
#define CR_T_6E (CR_T<<8)|0x6E
#define CR_T_6F (CR_T<<8)|0x6F
#define CR_T_70 (CR_T<<8)|0x70
#define CR_T_71 (CR_T<<8)|0x71
#define CR_T_72 (CR_T<<8)|0x72
#define CR_T_73 (CR_T<<8)|0x73
#define CR_T_74 (CR_T<<8)|0x74
#define CR_T_75 (CR_T<<8)|0x75
#define CR_T_76 (CR_T<<8)|0x76
#define CR_T_77 (CR_T<<8)|0x77
#define CR_T_78 (CR_T<<8)|0x78
#define CR_T_79 (CR_T<<8)|0x79
#define CR_T_7A (CR_T<<8)|0x7A
#define CR_T_7B (CR_T<<8)|0x7B
#define CR_T_7C (CR_T<<8)|0x7C
#define CR_T_7D (CR_T<<8)|0x7D
#define CR_T_7E (CR_T<<8)|0x7E
#define CR_T_7F (CR_T<<8)|0x7F
#define CR_T_80 (CR_T<<8)|0x80
#define CR_T_81 (CR_T<<8)|0x81
#define CR_T_82 (CR_T<<8)|0x82
#define CR_T_83 (CR_T<<8)|0x83
#define CR_T_84 (CR_T<<8)|0x84
#define CR_T_85 (CR_T<<8)|0x85
#define CR_T_86 (CR_T<<8)|0x86
#define CR_T_87 (CR_T<<8)|0x87
#define CR_T_88 (CR_T<<8)|0x88
#define CR_T_89 (CR_T<<8)|0x89
#define CR_T_8A (CR_T<<8)|0x8A
#define CR_T_8B (CR_T<<8)|0x8B
#define CR_T_8C (CR_T<<8)|0x8C
#define CR_T_8D (CR_T<<8)|0x8D
#define CR_T_8E (CR_T<<8)|0x8E
#define CR_T_8F (CR_T<<8)|0x8F
#define CR_T_90 (CR_T<<8)|0x90
#define CR_T_91 (CR_T<<8)|0x91
#define CR_T_92 (CR_T<<8)|0x92
#define CR_T_93 (CR_T<<8)|0x93
#define CR_T_94 (CR_T<<8)|0x94
#define CR_T_95 (CR_T<<8)|0x95
#define CR_T_96 (CR_T<<8)|0x96
#define CR_T_97 (CR_T<<8)|0x97
#define CR_T_98 (CR_T<<8)|0x98
#define CR_T_99 (CR_T<<8)|0x99
#define CR_T_9A (CR_T<<8)|0x9A
#define CR_T_9B (CR_T<<8)|0x9B
#define CR_T_9C (CR_T<<8)|0x9C
#define CR_T_9D (CR_T<<8)|0x9D
#define CR_T_9E (CR_T<<8)|0x9E
#define CR_T_9F (CR_T<<8)|0x9F
#define CR_T_A0 (CR_T<<8)|0xA0
#define CR_T_A1 (CR_T<<8)|0xA1
#define CR_T_A2 (CR_T<<8)|0xA2
#define CR_T_A3 (CR_T<<8)|0xA3
#define CR_T_A4 (CR_T<<8)|0xA4
#define CR_T_A5 (CR_T<<8)|0xA5
#define CR_T_A6 (CR_T<<8)|0xA6
#define CR_T_A7 (CR_T<<8)|0xA7
#define CR_T_A8 (CR_T<<8)|0xA8
#define CR_T_A9 (CR_T<<8)|0xA9
#define CR_T_AA (CR_T<<8)|0xAA
#define CR_T_AB (CR_T<<8)|0xAB
#define CR_T_AC (CR_T<<8)|0xAC
#define CR_T_AD (CR_T<<8)|0xAD
#define CR_T_AE (CR_T<<8)|0xAE
#define CR_T_AF (CR_T<<8)|0xAF
#define CR_T_B0 (CR_T<<8)|0xB0
#define CR_T_B1 (CR_T<<8)|0xB1
#define CR_T_B2 (CR_T<<8)|0xB2
#define CR_T_B3 (CR_T<<8)|0xB3
#define CR_T_B4 (CR_T<<8)|0xB4
#define CR_T_B5 (CR_T<<8)|0xB5
#define CR_T_B6 (CR_T<<8)|0xB6
#define CR_T_B7 (CR_T<<8)|0xB7
#define CR_T_B8 (CR_T<<8)|0xB8
#define CR_T_B9 (CR_T<<8)|0xB9
#define CR_T_BA (CR_T<<8)|0xBA
#define CR_T_BB (CR_T<<8)|0xBB
#define CR_T_BC (CR_T<<8)|0xBC
#define CR_T_BD (CR_T<<8)|0xBD
#define CR_T_BE (CR_T<<8)|0xBE
#define CR_T_BF (CR_T<<8)|0xBF
#define CR_T_C0 (CR_T<<8)|0xC0
#define CR_T_C1 (CR_T<<8)|0xC1
#define CR_T_C2 (CR_T<<8)|0xC2
#define CR_T_C3 (CR_T<<8)|0xC3
#define CR_T_C4 (CR_T<<8)|0xC4
#define CR_T_C5 (CR_T<<8)|0xC5
#define CR_T_C6 (CR_T<<8)|0xC6
#define CR_T_C7 (CR_T<<8)|0xC7
#define CR_T_C8 (CR_T<<8)|0xC8
#define CR_T_C9 (CR_T<<8)|0xC9
#define CR_T_CA (CR_T<<8)|0xCA
#define CR_T_CB (CR_T<<8)|0xCB
#define CR_T_CC (CR_T<<8)|0xCC
#define CR_T_CD (CR_T<<8)|0xCD
#define CR_T_CE (CR_T<<8)|0xCE
#define CR_T_CF (CR_T<<8)|0xCF
#define CR_T_D0 (CR_T<<8)|0xD0
#define CR_T_D1 (CR_T<<8)|0xD1
#define CR_T_D2 (CR_T<<8)|0xD2
#define CR_T_D3 (CR_T<<8)|0xD3
#define CR_T_D4 (CR_T<<8)|0xD4
#define CR_T_D5 (CR_T<<8)|0xD5
#define CR_T_D6 (CR_T<<8)|0xD6
#define CR_T_D7 (CR_T<<8)|0xD7
#define CR_T_D8 (CR_T<<8)|0xD8
#define CR_T_D9 (CR_T<<8)|0xD9
#define CR_T_DA (CR_T<<8)|0xDA
#define CR_T_DB (CR_T<<8)|0xDB
#define CR_T_DC (CR_T<<8)|0xDC
#define CR_T_DD (CR_T<<8)|0xDD
#define CR_T_DE (CR_T<<8)|0xDE
#define CR_T_DF (CR_T<<8)|0xDF
#define CR_T_E0 (CR_T<<8)|0xE0
#define CR_T_E1 (CR_T<<8)|0xE1
#define CR_T_E2 (CR_T<<8)|0xE2
#define CR_T_E3 (CR_T<<8)|0xE3
#define CR_T_E4 (CR_T<<8)|0xE4
#define CR_T_E5 (CR_T<<8)|0xE5
#define CR_T_E6 (CR_T<<8)|0xE6
#define CR_T_E7 (CR_T<<8)|0xE7
#define CR_T_E8 (CR_T<<8)|0xE8
#define CR_T_E9 (CR_T<<8)|0xE9
#define CR_T_EA (CR_T<<8)|0xEA
#define CR_T_EB (CR_T<<8)|0xEB
#define CR_T_EC (CR_T<<8)|0xEC
#define CR_T_ED (CR_T<<8)|0xED
#define CR_T_EE (CR_T<<8)|0xEE
#define CR_T_EF (CR_T<<8)|0xEF
#define CR_T_F0 (CR_T<<8)|0xF0
#define CR_T_F1 (CR_T<<8)|0xF1
#define CR_T_F2 (CR_T<<8)|0xF2
#define CR_T_F3 (CR_T<<8)|0xF3
#define CR_T_F4 (CR_T<<8)|0xF4
#define CR_T_F5 (CR_T<<8)|0xF5
#define CR_T_F6 (CR_T<<8)|0xF6
#define CR_T_F7 (CR_T<<8)|0xF7
#define CR_T_F8 (CR_T<<8)|0xF8
#define CR_T_F9 (CR_T<<8)|0xF9
#define CR_T_FA (CR_T<<8)|0xFA
#define CR_T_FB (CR_T<<8)|0xFB
#define CR_T_FC (CR_T<<8)|0xFC
#define CR_T_FD (CR_T<<8)|0xFD
#define CR_T_FE (CR_T<<8)|0xFE
#define CR_T_FF (CR_T<<8)|0xFF

#define CR_F_11 (CR_F<<8)|0x11
#define CR_F_35 (CR_F<<8)|0x35

#define CR_C_00 (CR_C<<8)|0x00
#define CR_C_01 (CR_C<<8)|0x01
#define CR_C_02 (CR_C<<8)|0x02
#define CR_C_03 (CR_C<<8)|0x03
#define CR_C_04 (CR_C<<8)|0x04
#define CR_C_05 (CR_C<<8)|0x05
#define CR_C_06 (CR_C<<8)|0x06
#define CR_C_07 (CR_C<<8)|0x07
#define CR_C_08 (CR_C<<8)|0x08
#define CR_C_09 (CR_C<<8)|0x09
#define CR_C_0A (CR_C<<8)|0x0A
#define CR_C_0B (CR_C<<8)|0x0B
#define CR_C_0C (CR_C<<8)|0x0C
#define CR_C_0D (CR_C<<8)|0x0D
#define CR_C_0E (CR_C<<8)|0x0E
#define CR_C_0F (CR_C<<8)|0x0F
#define CR_C_10 (CR_C<<8)|0x10
#define CR_C_11 (CR_C<<8)|0x11
#define CR_C_12 (CR_C<<8)|0x12
#define CR_C_13 (CR_C<<8)|0x13
#define CR_C_14 (CR_C<<8)|0x14
#define CR_C_15 (CR_C<<8)|0x15
#define CR_C_16 (CR_C<<8)|0x16
#define CR_C_17 (CR_C<<8)|0x17
#define CR_C_18 (CR_C<<8)|0x18
#define CR_C_19 (CR_C<<8)|0x19
#define CR_C_1A (CR_C<<8)|0x1A
#define CR_C_1B (CR_C<<8)|0x1B
#define CR_C_1C (CR_C<<8)|0x1C
#define CR_C_1D (CR_C<<8)|0x1D
#define CR_C_1E (CR_C<<8)|0x1E
#define CR_C_1F (CR_C<<8)|0x1F
#define CR_C_20 (CR_C<<8)|0x20
#define CR_C_21 (CR_C<<8)|0x21
#define CR_C_22 (CR_C<<8)|0x22
#define CR_C_23 (CR_C<<8)|0x23
#define CR_C_24 (CR_C<<8)|0x24
#define CR_C_25 (CR_C<<8)|0x25
#define CR_C_26 (CR_C<<8)|0x26
#define CR_C_27 (CR_C<<8)|0x27
#define CR_C_28 (CR_C<<8)|0x28
#define CR_C_29 (CR_C<<8)|0x29
#define CR_C_2A (CR_C<<8)|0x2A
#define CR_C_2B (CR_C<<8)|0x2B
#define CR_C_2C (CR_C<<8)|0x2C
#define CR_C_2D (CR_C<<8)|0x2D
#define CR_C_2E (CR_C<<8)|0x2E
#define CR_C_2F (CR_C<<8)|0x2F
#define CR_C_30 (CR_C<<8)|0x30
#define CR_C_31 (CR_C<<8)|0x31
#define CR_C_32 (CR_C<<8)|0x32
#define CR_C_33 (CR_C<<8)|0x33
#define CR_C_34 (CR_C<<8)|0x34
#define CR_C_35 (CR_C<<8)|0x35
#define CR_C_36 (CR_C<<8)|0x36
#define CR_C_37 (CR_C<<8)|0x37
#define CR_C_38 (CR_C<<8)|0x38
#define CR_C_39 (CR_C<<8)|0x39
#define CR_C_3A (CR_C<<8)|0x3A
#define CR_C_3B (CR_C<<8)|0x3B
#define CR_C_3C (CR_C<<8)|0x3C
#define CR_C_3D (CR_C<<8)|0x3D
#define CR_C_3E (CR_C<<8)|0x3E
#define CR_C_3F (CR_C<<8)|0x3F
#define CR_C_40 (CR_C<<8)|0x40
#define CR_C_41 (CR_C<<8)|0x41
#define CR_C_42 (CR_C<<8)|0x42
#define CR_C_43 (CR_C<<8)|0x43
#define CR_C_44 (CR_C<<8)|0x44
#define CR_C_45 (CR_C<<8)|0x45
#define CR_C_46 (CR_C<<8)|0x46
#define CR_C_47 (CR_C<<8)|0x47
#define CR_C_48 (CR_C<<8)|0x48
#define CR_C_49 (CR_C<<8)|0x49
#define CR_C_4A (CR_C<<8)|0x4A
#define CR_C_4B (CR_C<<8)|0x4B
#define CR_C_4C (CR_C<<8)|0x4C
#define CR_C_4D (CR_C<<8)|0x4D
#define CR_C_4E (CR_C<<8)|0x4E
#define CR_C_4F (CR_C<<8)|0x4F
#define CR_C_50 (CR_C<<8)|0x50
#define CR_C_51 (CR_C<<8)|0x51
#define CR_C_52 (CR_C<<8)|0x52
#define CR_C_53 (CR_C<<8)|0x53
#define CR_C_54 (CR_C<<8)|0x54
#define CR_C_55 (CR_C<<8)|0x55
#define CR_C_56 (CR_C<<8)|0x56
#define CR_C_57 (CR_C<<8)|0x57
#define CR_C_58 (CR_C<<8)|0x58
#define CR_C_59 (CR_C<<8)|0x59
#define CR_C_5A (CR_C<<8)|0x5A
#define CR_C_5B (CR_C<<8)|0x5B
#define CR_C_5C (CR_C<<8)|0x5C
#define CR_C_5D (CR_C<<8)|0x5D
#define CR_C_5E (CR_C<<8)|0x5E
#define CR_C_5F (CR_C<<8)|0x5F
#define CR_C_60 (CR_C<<8)|0x60
#define CR_C_61 (CR_C<<8)|0x61
#define CR_C_62 (CR_C<<8)|0x62
#define CR_C_63 (CR_C<<8)|0x63
#define CR_C_64 (CR_C<<8)|0x64
#define CR_C_65 (CR_C<<8)|0x65
#define CR_C_66 (CR_C<<8)|0x66
#define CR_C_67 (CR_C<<8)|0x67
#define CR_C_68 (CR_C<<8)|0x68
#define CR_C_69 (CR_C<<8)|0x69
#define CR_C_6A (CR_C<<8)|0x6A
#define CR_C_6B (CR_C<<8)|0x6B
#define CR_C_6C (CR_C<<8)|0x6C
#define CR_C_6D (CR_C<<8)|0x6D
#define CR_C_6E (CR_C<<8)|0x6E
#define CR_C_6F (CR_C<<8)|0x6F
#define CR_C_70 (CR_C<<8)|0x70
#define CR_C_71 (CR_C<<8)|0x71
#define CR_C_72 (CR_C<<8)|0x72
#define CR_C_73 (CR_C<<8)|0x73
#define CR_C_74 (CR_C<<8)|0x74
#define CR_C_75 (CR_C<<8)|0x75
#define CR_C_76 (CR_C<<8)|0x76
#define CR_C_77 (CR_C<<8)|0x77
#define CR_C_78 (CR_C<<8)|0x78
#define CR_C_79 (CR_C<<8)|0x79
#define CR_C_7A (CR_C<<8)|0x7A
#define CR_C_7B (CR_C<<8)|0x7B
#define CR_C_7C (CR_C<<8)|0x7C
#define CR_C_7D (CR_C<<8)|0x7D
#define CR_C_7E (CR_C<<8)|0x7E
#define CR_C_7F (CR_C<<8)|0x7F
#define CR_C_80 (CR_C<<8)|0x80
#define CR_C_81 (CR_C<<8)|0x81
#define CR_C_82 (CR_C<<8)|0x82
#define CR_C_83 (CR_C<<8)|0x83
#define CR_C_84 (CR_C<<8)|0x84
#define CR_C_85 (CR_C<<8)|0x85
#define CR_C_86 (CR_C<<8)|0x86
#define CR_C_87 (CR_C<<8)|0x87
#define CR_C_88 (CR_C<<8)|0x88
#define CR_C_89 (CR_C<<8)|0x89
#define CR_C_8A (CR_C<<8)|0x8A
#define CR_C_8B (CR_C<<8)|0x8B
#define CR_C_8C (CR_C<<8)|0x8C
#define CR_C_8D (CR_C<<8)|0x8D
#define CR_C_8E (CR_C<<8)|0x8E
#define CR_C_8F (CR_C<<8)|0x8F
#define CR_C_90 (CR_C<<8)|0x90
#define CR_C_91 (CR_C<<8)|0x91
#define CR_C_92 (CR_C<<8)|0x92
#define CR_C_93 (CR_C<<8)|0x93
#define CR_C_94 (CR_C<<8)|0x94
#define CR_C_95 (CR_C<<8)|0x95
#define CR_C_96 (CR_C<<8)|0x96
#define CR_C_97 (CR_C<<8)|0x97
#define CR_C_98 (CR_C<<8)|0x98
#define CR_C_99 (CR_C<<8)|0x99
#define CR_C_9A (CR_C<<8)|0x9A
#define CR_C_9B (CR_C<<8)|0x9B
#define CR_C_9C (CR_C<<8)|0x9C
#define CR_C_9D (CR_C<<8)|0x9D
#define CR_C_9E (CR_C<<8)|0x9E
#define CR_C_9F (CR_C<<8)|0x9F
#define CR_C_A0 (CR_C<<8)|0xA0
#define CR_C_A1 (CR_C<<8)|0xA1
#define CR_C_A2 (CR_C<<8)|0xA2
#define CR_C_A3 (CR_C<<8)|0xA3
#define CR_C_A4 (CR_C<<8)|0xA4
#define CR_C_A5 (CR_C<<8)|0xA5
#define CR_C_A6 (CR_C<<8)|0xA6
#define CR_C_A7 (CR_C<<8)|0xA7
#define CR_C_A8 (CR_C<<8)|0xA8
#define CR_C_A9 (CR_C<<8)|0xA9
#define CR_C_AA (CR_C<<8)|0xAA
#define CR_C_AB (CR_C<<8)|0xAB
#define CR_C_AC (CR_C<<8)|0xAC
#define CR_C_AD (CR_C<<8)|0xAD
#define CR_C_AE (CR_C<<8)|0xAE
#define CR_C_AF (CR_C<<8)|0xAF
#define CR_C_B0 (CR_C<<8)|0xB0
#define CR_C_B1 (CR_C<<8)|0xB1
#define CR_C_B2 (CR_C<<8)|0xB2
#define CR_C_B3 (CR_C<<8)|0xB3
#define CR_C_B4 (CR_C<<8)|0xB4
#define CR_C_B5 (CR_C<<8)|0xB5
#define CR_C_B6 (CR_C<<8)|0xB6
#define CR_C_B7 (CR_C<<8)|0xB7
#define CR_C_B8 (CR_C<<8)|0xB8
#define CR_C_B9 (CR_C<<8)|0xB9
#define CR_C_BA (CR_C<<8)|0xBA
#define CR_C_BB (CR_C<<8)|0xBB
#define CR_C_BC (CR_C<<8)|0xBC
#define CR_C_BD (CR_C<<8)|0xBD
#define CR_C_BE (CR_C<<8)|0xBE
#define CR_C_BF (CR_C<<8)|0xBF
#define CR_C_C0 (CR_C<<8)|0xC0
#define CR_C_C1 (CR_C<<8)|0xC1
#define CR_C_C2 (CR_C<<8)|0xC2
#define CR_C_C3 (CR_C<<8)|0xC3
#define CR_C_C4 (CR_C<<8)|0xC4
#define CR_C_C5 (CR_C<<8)|0xC5
#define CR_C_C6 (CR_C<<8)|0xC6
#define CR_C_C7 (CR_C<<8)|0xC7
#define CR_C_C8 (CR_C<<8)|0xC8
#define CR_C_C9 (CR_C<<8)|0xC9
#define CR_C_CA (CR_C<<8)|0xCA
#define CR_C_CB (CR_C<<8)|0xCB
#define CR_C_CC (CR_C<<8)|0xCC
#define CR_C_CD (CR_C<<8)|0xCD
#define CR_C_CE (CR_C<<8)|0xCE
#define CR_C_CF (CR_C<<8)|0xCF
#define CR_C_D0 (CR_C<<8)|0xD0
#define CR_C_D1 (CR_C<<8)|0xD1
#define CR_C_D2 (CR_C<<8)|0xD2
#define CR_C_D3 (CR_C<<8)|0xD3
#define CR_C_D4 (CR_C<<8)|0xD4
#define CR_C_D5 (CR_C<<8)|0xD5
#define CR_C_D6 (CR_C<<8)|0xD6
#define CR_C_D7 (CR_C<<8)|0xD7
#define CR_C_D8 (CR_C<<8)|0xD8
#define CR_C_D9 (CR_C<<8)|0xD9
#define CR_C_DA (CR_C<<8)|0xDA
#define CR_C_DB (CR_C<<8)|0xDB
#define CR_C_DC (CR_C<<8)|0xDC
#define CR_C_DD (CR_C<<8)|0xDD
#define CR_C_DE (CR_C<<8)|0xDE
#define CR_C_DF (CR_C<<8)|0xDF
#define CR_C_E0 (CR_C<<8)|0xE0
#define CR_C_E1 (CR_C<<8)|0xE1
#define CR_C_E2 (CR_C<<8)|0xE2
#define CR_C_E3 (CR_C<<8)|0xE3
#define CR_C_E4 (CR_C<<8)|0xE4
#define CR_C_E5 (CR_C<<8)|0xE5
#define CR_C_E6 (CR_C<<8)|0xE6
#define CR_C_E7 (CR_C<<8)|0xE7
#define CR_C_E8 (CR_C<<8)|0xE8
#define CR_C_E9 (CR_C<<8)|0xE9
#define CR_C_EA (CR_C<<8)|0xEA
#define CR_C_EB (CR_C<<8)|0xEB
#define CR_C_EC (CR_C<<8)|0xEC
#define CR_C_ED (CR_C<<8)|0xED
#define CR_C_EE (CR_C<<8)|0xEE
#define CR_C_EF (CR_C<<8)|0xEF
#define CR_C_F0 (CR_C<<8)|0xF0
#define CR_C_F1 (CR_C<<8)|0xF1
#define CR_C_F2 (CR_C<<8)|0xF2
#define CR_C_F3 (CR_C<<8)|0xF3
#define CR_C_F4 (CR_C<<8)|0xF4
#define CR_C_F5 (CR_C<<8)|0xF5
#define CR_C_F6 (CR_C<<8)|0xF6
#define CR_C_F7 (CR_C<<8)|0xF7
#define CR_C_F8 (CR_C<<8)|0xF8
#define CR_C_F9 (CR_C<<8)|0xF9
#define CR_C_FA (CR_C<<8)|0xFA
#define CR_C_FB (CR_C<<8)|0xFB
#define CR_C_FC (CR_C<<8)|0xFC
#define CR_C_FD (CR_C<<8)|0xFD
#define CR_C_FE (CR_C<<8)|0xFE
#define CR_C_FF (CR_C<<8)|0xFF

#define CR_D_1_00 (CR_D_1<<8)|0x00
#define CR_D_1_01 (CR_D_1<<8)|0x01
#define CR_D_1_02 (CR_D_1<<8)|0x02
#define CR_D_1_03 (CR_D_1<<8)|0x03
#define CR_D_1_04 (CR_D_1<<8)|0x04
#define CR_D_1_05 (CR_D_1<<8)|0x05
#define CR_D_1_06 (CR_D_1<<8)|0x06
#define CR_D_1_07 (CR_D_1<<8)|0x07
#define CR_D_1_08 (CR_D_1<<8)|0x08
#define CR_D_1_09 (CR_D_1<<8)|0x09
#define CR_D_1_0A (CR_D_1<<8)|0x0A
#define CR_D_1_0B (CR_D_1<<8)|0x0B
#define CR_D_1_0C (CR_D_1<<8)|0x0C
#define CR_D_1_0D (CR_D_1<<8)|0x0D
#define CR_D_1_0E (CR_D_1<<8)|0x0E
#define CR_D_1_0F (CR_D_1<<8)|0x0F
#define CR_D_1_10 (CR_D_1<<8)|0x10
#define CR_D_1_11 (CR_D_1<<8)|0x11
#define CR_D_1_12 (CR_D_1<<8)|0x12
#define CR_D_1_13 (CR_D_1<<8)|0x13
#define CR_D_1_14 (CR_D_1<<8)|0x14
#define CR_D_1_15 (CR_D_1<<8)|0x15
#define CR_D_1_16 (CR_D_1<<8)|0x16
#define CR_D_1_17 (CR_D_1<<8)|0x17
#define CR_D_1_18 (CR_D_1<<8)|0x18
#define CR_D_1_19 (CR_D_1<<8)|0x19
#define CR_D_1_1A (CR_D_1<<8)|0x1A
#define CR_D_1_1B (CR_D_1<<8)|0x1B
#define CR_D_1_1C (CR_D_1<<8)|0x1C
#define CR_D_1_1D (CR_D_1<<8)|0x1D
#define CR_D_1_1E (CR_D_1<<8)|0x1E
#define CR_D_1_1F (CR_D_1<<8)|0x1F
#define CR_D_1_20 (CR_D_1<<8)|0x20
#define CR_D_1_21 (CR_D_1<<8)|0x21
#define CR_D_1_22 (CR_D_1<<8)|0x22
#define CR_D_1_23 (CR_D_1<<8)|0x23
#define CR_D_1_24 (CR_D_1<<8)|0x24
#define CR_D_1_25 (CR_D_1<<8)|0x25
#define CR_D_1_26 (CR_D_1<<8)|0x26
#define CR_D_1_27 (CR_D_1<<8)|0x27
#define CR_D_1_28 (CR_D_1<<8)|0x28
#define CR_D_1_29 (CR_D_1<<8)|0x29
#define CR_D_1_2A (CR_D_1<<8)|0x2A
#define CR_D_1_2B (CR_D_1<<8)|0x2B
#define CR_D_1_2C (CR_D_1<<8)|0x2C
#define CR_D_1_2D (CR_D_1<<8)|0x2D
#define CR_D_1_2E (CR_D_1<<8)|0x2E
#define CR_D_1_2F (CR_D_1<<8)|0x2F
#define CR_D_1_30 (CR_D_1<<8)|0x30
#define CR_D_1_31 (CR_D_1<<8)|0x31
#define CR_D_1_32 (CR_D_1<<8)|0x32
#define CR_D_1_33 (CR_D_1<<8)|0x33
#define CR_D_1_34 (CR_D_1<<8)|0x34
#define CR_D_1_35 (CR_D_1<<8)|0x35
#define CR_D_1_36 (CR_D_1<<8)|0x36
#define CR_D_1_37 (CR_D_1<<8)|0x37
#define CR_D_1_38 (CR_D_1<<8)|0x38
#define CR_D_1_39 (CR_D_1<<8)|0x39
#define CR_D_1_3A (CR_D_1<<8)|0x3A
#define CR_D_1_3B (CR_D_1<<8)|0x3B
#define CR_D_1_3C (CR_D_1<<8)|0x3C
#define CR_D_1_3D (CR_D_1<<8)|0x3D
#define CR_D_1_3E (CR_D_1<<8)|0x3E
#define CR_D_1_3F (CR_D_1<<8)|0x3F
#define CR_D_1_40 (CR_D_1<<8)|0x40
#define CR_D_1_41 (CR_D_1<<8)|0x41
#define CR_D_1_42 (CR_D_1<<8)|0x42
#define CR_D_1_43 (CR_D_1<<8)|0x43
#define CR_D_1_44 (CR_D_1<<8)|0x44
#define CR_D_1_45 (CR_D_1<<8)|0x45
#define CR_D_1_46 (CR_D_1<<8)|0x46
#define CR_D_1_47 (CR_D_1<<8)|0x47
#define CR_D_1_48 (CR_D_1<<8)|0x48
#define CR_D_1_49 (CR_D_1<<8)|0x49
#define CR_D_1_4A (CR_D_1<<8)|0x4A
#define CR_D_1_4B (CR_D_1<<8)|0x4B
#define CR_D_1_4C (CR_D_1<<8)|0x4C
#define CR_D_1_4D (CR_D_1<<8)|0x4D
#define CR_D_1_4E (CR_D_1<<8)|0x4E
#define CR_D_1_4F (CR_D_1<<8)|0x4F
#define CR_D_1_50 (CR_D_1<<8)|0x50
#define CR_D_1_51 (CR_D_1<<8)|0x51
#define CR_D_1_52 (CR_D_1<<8)|0x52
#define CR_D_1_53 (CR_D_1<<8)|0x53
#define CR_D_1_54 (CR_D_1<<8)|0x54
#define CR_D_1_55 (CR_D_1<<8)|0x55
#define CR_D_1_56 (CR_D_1<<8)|0x56
#define CR_D_1_57 (CR_D_1<<8)|0x57
#define CR_D_1_58 (CR_D_1<<8)|0x58
#define CR_D_1_59 (CR_D_1<<8)|0x59
#define CR_D_1_5A (CR_D_1<<8)|0x5A
#define CR_D_1_5B (CR_D_1<<8)|0x5B
#define CR_D_1_5C (CR_D_1<<8)|0x5C
#define CR_D_1_5D (CR_D_1<<8)|0x5D
#define CR_D_1_5E (CR_D_1<<8)|0x5E
#define CR_D_1_5F (CR_D_1<<8)|0x5F
#define CR_D_1_60 (CR_D_1<<8)|0x60
#define CR_D_1_61 (CR_D_1<<8)|0x61
#define CR_D_1_62 (CR_D_1<<8)|0x62
#define CR_D_1_63 (CR_D_1<<8)|0x63
#define CR_D_1_64 (CR_D_1<<8)|0x64
#define CR_D_1_65 (CR_D_1<<8)|0x65
#define CR_D_1_66 (CR_D_1<<8)|0x66
#define CR_D_1_67 (CR_D_1<<8)|0x67
#define CR_D_1_68 (CR_D_1<<8)|0x68
#define CR_D_1_69 (CR_D_1<<8)|0x69
#define CR_D_1_6A (CR_D_1<<8)|0x6A
#define CR_D_1_6B (CR_D_1<<8)|0x6B
#define CR_D_1_6C (CR_D_1<<8)|0x6C
#define CR_D_1_6D (CR_D_1<<8)|0x6D
#define CR_D_1_6E (CR_D_1<<8)|0x6E
#define CR_D_1_6F (CR_D_1<<8)|0x6F
#define CR_D_1_70 (CR_D_1<<8)|0x70
#define CR_D_1_71 (CR_D_1<<8)|0x71
#define CR_D_1_72 (CR_D_1<<8)|0x72
#define CR_D_1_73 (CR_D_1<<8)|0x73
#define CR_D_1_74 (CR_D_1<<8)|0x74
#define CR_D_1_75 (CR_D_1<<8)|0x75
#define CR_D_1_76 (CR_D_1<<8)|0x76
#define CR_D_1_77 (CR_D_1<<8)|0x77
#define CR_D_1_78 (CR_D_1<<8)|0x78
#define CR_D_1_79 (CR_D_1<<8)|0x79
#define CR_D_1_7A (CR_D_1<<8)|0x7A
#define CR_D_1_7B (CR_D_1<<8)|0x7B
#define CR_D_1_7C (CR_D_1<<8)|0x7C
#define CR_D_1_7D (CR_D_1<<8)|0x7D
#define CR_D_1_7E (CR_D_1<<8)|0x7E
#define CR_D_1_7F (CR_D_1<<8)|0x7F
#define CR_D_1_80 (CR_D_1<<8)|0x80
#define CR_D_1_81 (CR_D_1<<8)|0x81
#define CR_D_1_82 (CR_D_1<<8)|0x82
#define CR_D_1_83 (CR_D_1<<8)|0x83
#define CR_D_1_84 (CR_D_1<<8)|0x84
#define CR_D_1_85 (CR_D_1<<8)|0x85
#define CR_D_1_86 (CR_D_1<<8)|0x86
#define CR_D_1_87 (CR_D_1<<8)|0x87
#define CR_D_1_88 (CR_D_1<<8)|0x88
#define CR_D_1_89 (CR_D_1<<8)|0x89
#define CR_D_1_8A (CR_D_1<<8)|0x8A
#define CR_D_1_8B (CR_D_1<<8)|0x8B
#define CR_D_1_8C (CR_D_1<<8)|0x8C
#define CR_D_1_8D (CR_D_1<<8)|0x8D
#define CR_D_1_8E (CR_D_1<<8)|0x8E
#define CR_D_1_8F (CR_D_1<<8)|0x8F
#define CR_D_1_90 (CR_D_1<<8)|0x90
#define CR_D_1_91 (CR_D_1<<8)|0x91
#define CR_D_1_92 (CR_D_1<<8)|0x92
#define CR_D_1_93 (CR_D_1<<8)|0x93
#define CR_D_1_94 (CR_D_1<<8)|0x94
#define CR_D_1_95 (CR_D_1<<8)|0x95
#define CR_D_1_96 (CR_D_1<<8)|0x96
#define CR_D_1_97 (CR_D_1<<8)|0x97
#define CR_D_1_98 (CR_D_1<<8)|0x98
#define CR_D_1_99 (CR_D_1<<8)|0x99
#define CR_D_1_9A (CR_D_1<<8)|0x9A
#define CR_D_1_9B (CR_D_1<<8)|0x9B
#define CR_D_1_9C (CR_D_1<<8)|0x9C
#define CR_D_1_9D (CR_D_1<<8)|0x9D
#define CR_D_1_9E (CR_D_1<<8)|0x9E
#define CR_D_1_9F (CR_D_1<<8)|0x9F
#define CR_D_1_A0 (CR_D_1<<8)|0xA0
#define CR_D_1_A1 (CR_D_1<<8)|0xA1
#define CR_D_1_A2 (CR_D_1<<8)|0xA2
#define CR_D_1_A3 (CR_D_1<<8)|0xA3
#define CR_D_1_A4 (CR_D_1<<8)|0xA4
#define CR_D_1_A5 (CR_D_1<<8)|0xA5
#define CR_D_1_A6 (CR_D_1<<8)|0xA6
#define CR_D_1_A7 (CR_D_1<<8)|0xA7
#define CR_D_1_A8 (CR_D_1<<8)|0xA8
#define CR_D_1_A9 (CR_D_1<<8)|0xA9
#define CR_D_1_AA (CR_D_1<<8)|0xAA
#define CR_D_1_AB (CR_D_1<<8)|0xAB
#define CR_D_1_AC (CR_D_1<<8)|0xAC
#define CR_D_1_AD (CR_D_1<<8)|0xAD
#define CR_D_1_AE (CR_D_1<<8)|0xAE
#define CR_D_1_AF (CR_D_1<<8)|0xAF
#define CR_D_1_B0 (CR_D_1<<8)|0xB0
#define CR_D_1_B1 (CR_D_1<<8)|0xB1
#define CR_D_1_B2 (CR_D_1<<8)|0xB2
#define CR_D_1_B3 (CR_D_1<<8)|0xB3
#define CR_D_1_B4 (CR_D_1<<8)|0xB4
#define CR_D_1_B5 (CR_D_1<<8)|0xB5
#define CR_D_1_B6 (CR_D_1<<8)|0xB6
#define CR_D_1_B7 (CR_D_1<<8)|0xB7
#define CR_D_1_B8 (CR_D_1<<8)|0xB8
#define CR_D_1_B9 (CR_D_1<<8)|0xB9
#define CR_D_1_BA (CR_D_1<<8)|0xBA
#define CR_D_1_BB (CR_D_1<<8)|0xBB
#define CR_D_1_BC (CR_D_1<<8)|0xBC
#define CR_D_1_BD (CR_D_1<<8)|0xBD
#define CR_D_1_BE (CR_D_1<<8)|0xBE
#define CR_D_1_BF (CR_D_1<<8)|0xBF
#define CR_D_1_C0 (CR_D_1<<8)|0xC0
#define CR_D_1_C1 (CR_D_1<<8)|0xC1
#define CR_D_1_C2 (CR_D_1<<8)|0xC2
#define CR_D_1_C3 (CR_D_1<<8)|0xC3
#define CR_D_1_C4 (CR_D_1<<8)|0xC4
#define CR_D_1_C5 (CR_D_1<<8)|0xC5
#define CR_D_1_C6 (CR_D_1<<8)|0xC6
#define CR_D_1_C7 (CR_D_1<<8)|0xC7
#define CR_D_1_C8 (CR_D_1<<8)|0xC8
#define CR_D_1_C9 (CR_D_1<<8)|0xC9
#define CR_D_1_CA (CR_D_1<<8)|0xCA
#define CR_D_1_CB (CR_D_1<<8)|0xCB
#define CR_D_1_CC (CR_D_1<<8)|0xCC
#define CR_D_1_CD (CR_D_1<<8)|0xCD
#define CR_D_1_CE (CR_D_1<<8)|0xCE
#define CR_D_1_CF (CR_D_1<<8)|0xCF
#define CR_D_1_D0 (CR_D_1<<8)|0xD0
#define CR_D_1_D1 (CR_D_1<<8)|0xD1
#define CR_D_1_D2 (CR_D_1<<8)|0xD2
#define CR_D_1_D3 (CR_D_1<<8)|0xD3
#define CR_D_1_D4 (CR_D_1<<8)|0xD4
#define CR_D_1_D5 (CR_D_1<<8)|0xD5
#define CR_D_1_D6 (CR_D_1<<8)|0xD6
#define CR_D_1_D7 (CR_D_1<<8)|0xD7
#define CR_D_1_D8 (CR_D_1<<8)|0xD8
#define CR_D_1_D9 (CR_D_1<<8)|0xD9
#define CR_D_1_DA (CR_D_1<<8)|0xDA
#define CR_D_1_DB (CR_D_1<<8)|0xDB
#define CR_D_1_DC (CR_D_1<<8)|0xDC
#define CR_D_1_DD (CR_D_1<<8)|0xDD
#define CR_D_1_DE (CR_D_1<<8)|0xDE
#define CR_D_1_DF (CR_D_1<<8)|0xDF
#define CR_D_1_E0 (CR_D_1<<8)|0xE0
#define CR_D_1_E1 (CR_D_1<<8)|0xE1
#define CR_D_1_E2 (CR_D_1<<8)|0xE2
#define CR_D_1_E3 (CR_D_1<<8)|0xE3
#define CR_D_1_E4 (CR_D_1<<8)|0xE4
#define CR_D_1_E5 (CR_D_1<<8)|0xE5
#define CR_D_1_E6 (CR_D_1<<8)|0xE6
#define CR_D_1_E7 (CR_D_1<<8)|0xE7
#define CR_D_1_E8 (CR_D_1<<8)|0xE8
#define CR_D_1_E9 (CR_D_1<<8)|0xE9
#define CR_D_1_EA (CR_D_1<<8)|0xEA
#define CR_D_1_EB (CR_D_1<<8)|0xEB
#define CR_D_1_EC (CR_D_1<<8)|0xEC
#define CR_D_1_ED (CR_D_1<<8)|0xED
#define CR_D_1_EE (CR_D_1<<8)|0xEE
#define CR_D_1_EF (CR_D_1<<8)|0xEF
#define CR_D_1_F0 (CR_D_1<<8)|0xF0
#define CR_D_1_F1 (CR_D_1<<8)|0xF1
#define CR_D_1_F2 (CR_D_1<<8)|0xF2
#define CR_D_1_F3 (CR_D_1<<8)|0xF3
#define CR_D_1_F4 (CR_D_1<<8)|0xF4
#define CR_D_1_F5 (CR_D_1<<8)|0xF5
#define CR_D_1_F6 (CR_D_1<<8)|0xF6
#define CR_D_1_F7 (CR_D_1<<8)|0xF7
#define CR_D_1_F8 (CR_D_1<<8)|0xF8
#define CR_D_1_F9 (CR_D_1<<8)|0xF9
#define CR_D_1_FA (CR_D_1<<8)|0xFA
#define CR_D_1_FB (CR_D_1<<8)|0xFB
#define CR_D_1_FC (CR_D_1<<8)|0xFC
#define CR_D_1_FD (CR_D_1<<8)|0xFD
#define CR_D_1_FE (CR_D_1<<8)|0xFE
#define CR_D_1_FF (CR_D_1<<8)|0xFF

#define CR_D_2_00 (CR_D_2<<8)|0x00
#define CR_D_2_01 (CR_D_2<<8)|0x01
#define CR_D_2_02 (CR_D_2<<8)|0x02
#define CR_D_2_03 (CR_D_2<<8)|0x03
#define CR_D_2_04 (CR_D_2<<8)|0x04
#define CR_D_2_05 (CR_D_2<<8)|0x05
#define CR_D_2_06 (CR_D_2<<8)|0x06
#define CR_D_2_07 (CR_D_2<<8)|0x07
#define CR_D_2_08 (CR_D_2<<8)|0x08
#define CR_D_2_09 (CR_D_2<<8)|0x09
#define CR_D_2_0A (CR_D_2<<8)|0x0A
#define CR_D_2_0B (CR_D_2<<8)|0x0B
#define CR_D_2_0C (CR_D_2<<8)|0x0C
#define CR_D_2_0D (CR_D_2<<8)|0x0D
#define CR_D_2_0E (CR_D_2<<8)|0x0E
#define CR_D_2_0F (CR_D_2<<8)|0x0F
#define CR_D_2_10 (CR_D_2<<8)|0x10
#define CR_D_2_11 (CR_D_2<<8)|0x11
#define CR_D_2_12 (CR_D_2<<8)|0x12
#define CR_D_2_13 (CR_D_2<<8)|0x13
#define CR_D_2_14 (CR_D_2<<8)|0x14
#define CR_D_2_15 (CR_D_2<<8)|0x15
#define CR_D_2_16 (CR_D_2<<8)|0x16
#define CR_D_2_17 (CR_D_2<<8)|0x17
#define CR_D_2_18 (CR_D_2<<8)|0x18
#define CR_D_2_19 (CR_D_2<<8)|0x19
#define CR_D_2_1A (CR_D_2<<8)|0x1A
#define CR_D_2_1B (CR_D_2<<8)|0x1B
#define CR_D_2_1C (CR_D_2<<8)|0x1C
#define CR_D_2_1D (CR_D_2<<8)|0x1D
#define CR_D_2_1E (CR_D_2<<8)|0x1E
#define CR_D_2_1F (CR_D_2<<8)|0x1F
#define CR_D_2_20 (CR_D_2<<8)|0x20
#define CR_D_2_21 (CR_D_2<<8)|0x21
#define CR_D_2_22 (CR_D_2<<8)|0x22
#define CR_D_2_23 (CR_D_2<<8)|0x23
#define CR_D_2_24 (CR_D_2<<8)|0x24
#define CR_D_2_25 (CR_D_2<<8)|0x25
#define CR_D_2_26 (CR_D_2<<8)|0x26
#define CR_D_2_27 (CR_D_2<<8)|0x27
#define CR_D_2_28 (CR_D_2<<8)|0x28
#define CR_D_2_29 (CR_D_2<<8)|0x29
#define CR_D_2_2A (CR_D_2<<8)|0x2A
#define CR_D_2_2B (CR_D_2<<8)|0x2B
#define CR_D_2_2C (CR_D_2<<8)|0x2C
#define CR_D_2_2D (CR_D_2<<8)|0x2D
#define CR_D_2_2E (CR_D_2<<8)|0x2E
#define CR_D_2_2F (CR_D_2<<8)|0x2F
#define CR_D_2_30 (CR_D_2<<8)|0x30
#define CR_D_2_31 (CR_D_2<<8)|0x31
#define CR_D_2_32 (CR_D_2<<8)|0x32
#define CR_D_2_33 (CR_D_2<<8)|0x33
#define CR_D_2_34 (CR_D_2<<8)|0x34
#define CR_D_2_35 (CR_D_2<<8)|0x35
#define CR_D_2_36 (CR_D_2<<8)|0x36
#define CR_D_2_37 (CR_D_2<<8)|0x37
#define CR_D_2_38 (CR_D_2<<8)|0x38
#define CR_D_2_39 (CR_D_2<<8)|0x39
#define CR_D_2_3A (CR_D_2<<8)|0x3A
#define CR_D_2_3B (CR_D_2<<8)|0x3B
#define CR_D_2_3C (CR_D_2<<8)|0x3C
#define CR_D_2_3D (CR_D_2<<8)|0x3D
#define CR_D_2_3E (CR_D_2<<8)|0x3E
#define CR_D_2_3F (CR_D_2<<8)|0x3F
#define CR_D_2_40 (CR_D_2<<8)|0x40
#define CR_D_2_41 (CR_D_2<<8)|0x41
#define CR_D_2_42 (CR_D_2<<8)|0x42
#define CR_D_2_43 (CR_D_2<<8)|0x43
#define CR_D_2_44 (CR_D_2<<8)|0x44
#define CR_D_2_45 (CR_D_2<<8)|0x45
#define CR_D_2_46 (CR_D_2<<8)|0x46
#define CR_D_2_47 (CR_D_2<<8)|0x47
#define CR_D_2_48 (CR_D_2<<8)|0x48
#define CR_D_2_49 (CR_D_2<<8)|0x49
#define CR_D_2_4A (CR_D_2<<8)|0x4A
#define CR_D_2_4B (CR_D_2<<8)|0x4B
#define CR_D_2_4C (CR_D_2<<8)|0x4C
#define CR_D_2_4D (CR_D_2<<8)|0x4D
#define CR_D_2_4E (CR_D_2<<8)|0x4E
#define CR_D_2_4F (CR_D_2<<8)|0x4F
#define CR_D_2_50 (CR_D_2<<8)|0x50
#define CR_D_2_51 (CR_D_2<<8)|0x51
#define CR_D_2_52 (CR_D_2<<8)|0x52
#define CR_D_2_53 (CR_D_2<<8)|0x53
#define CR_D_2_54 (CR_D_2<<8)|0x54
#define CR_D_2_55 (CR_D_2<<8)|0x55
#define CR_D_2_56 (CR_D_2<<8)|0x56
#define CR_D_2_57 (CR_D_2<<8)|0x57
#define CR_D_2_58 (CR_D_2<<8)|0x58
#define CR_D_2_59 (CR_D_2<<8)|0x59
#define CR_D_2_5A (CR_D_2<<8)|0x5A
#define CR_D_2_5B (CR_D_2<<8)|0x5B
#define CR_D_2_5C (CR_D_2<<8)|0x5C
#define CR_D_2_5D (CR_D_2<<8)|0x5D
#define CR_D_2_5E (CR_D_2<<8)|0x5E
#define CR_D_2_5F (CR_D_2<<8)|0x5F
#define CR_D_2_60 (CR_D_2<<8)|0x60
#define CR_D_2_61 (CR_D_2<<8)|0x61
#define CR_D_2_62 (CR_D_2<<8)|0x62
#define CR_D_2_63 (CR_D_2<<8)|0x63
#define CR_D_2_64 (CR_D_2<<8)|0x64
#define CR_D_2_65 (CR_D_2<<8)|0x65
#define CR_D_2_66 (CR_D_2<<8)|0x66
#define CR_D_2_67 (CR_D_2<<8)|0x67
#define CR_D_2_68 (CR_D_2<<8)|0x68
#define CR_D_2_69 (CR_D_2<<8)|0x69
#define CR_D_2_6A (CR_D_2<<8)|0x6A
#define CR_D_2_6B (CR_D_2<<8)|0x6B
#define CR_D_2_6C (CR_D_2<<8)|0x6C
#define CR_D_2_6D (CR_D_2<<8)|0x6D
#define CR_D_2_6E (CR_D_2<<8)|0x6E
#define CR_D_2_6F (CR_D_2<<8)|0x6F
#define CR_D_2_70 (CR_D_2<<8)|0x70
#define CR_D_2_71 (CR_D_2<<8)|0x71
#define CR_D_2_72 (CR_D_2<<8)|0x72
#define CR_D_2_73 (CR_D_2<<8)|0x73
#define CR_D_2_74 (CR_D_2<<8)|0x74
#define CR_D_2_75 (CR_D_2<<8)|0x75
#define CR_D_2_76 (CR_D_2<<8)|0x76
#define CR_D_2_77 (CR_D_2<<8)|0x77
#define CR_D_2_78 (CR_D_2<<8)|0x78
#define CR_D_2_79 (CR_D_2<<8)|0x79
#define CR_D_2_7A (CR_D_2<<8)|0x7A
#define CR_D_2_7B (CR_D_2<<8)|0x7B
#define CR_D_2_7C (CR_D_2<<8)|0x7C
#define CR_D_2_7D (CR_D_2<<8)|0x7D
#define CR_D_2_7E (CR_D_2<<8)|0x7E
#define CR_D_2_7F (CR_D_2<<8)|0x7F
#define CR_D_2_80 (CR_D_2<<8)|0x80
#define CR_D_2_81 (CR_D_2<<8)|0x81
#define CR_D_2_82 (CR_D_2<<8)|0x82
#define CR_D_2_83 (CR_D_2<<8)|0x83
#define CR_D_2_84 (CR_D_2<<8)|0x84
#define CR_D_2_85 (CR_D_2<<8)|0x85
#define CR_D_2_86 (CR_D_2<<8)|0x86
#define CR_D_2_87 (CR_D_2<<8)|0x87
#define CR_D_2_88 (CR_D_2<<8)|0x88
#define CR_D_2_89 (CR_D_2<<8)|0x89
#define CR_D_2_8A (CR_D_2<<8)|0x8A
#define CR_D_2_8B (CR_D_2<<8)|0x8B
#define CR_D_2_8C (CR_D_2<<8)|0x8C
#define CR_D_2_8D (CR_D_2<<8)|0x8D
#define CR_D_2_8E (CR_D_2<<8)|0x8E
#define CR_D_2_8F (CR_D_2<<8)|0x8F
#define CR_D_2_90 (CR_D_2<<8)|0x90
#define CR_D_2_91 (CR_D_2<<8)|0x91
#define CR_D_2_92 (CR_D_2<<8)|0x92
#define CR_D_2_93 (CR_D_2<<8)|0x93
#define CR_D_2_94 (CR_D_2<<8)|0x94
#define CR_D_2_95 (CR_D_2<<8)|0x95
#define CR_D_2_96 (CR_D_2<<8)|0x96
#define CR_D_2_97 (CR_D_2<<8)|0x97
#define CR_D_2_98 (CR_D_2<<8)|0x98
#define CR_D_2_99 (CR_D_2<<8)|0x99
#define CR_D_2_9A (CR_D_2<<8)|0x9A
#define CR_D_2_9B (CR_D_2<<8)|0x9B
#define CR_D_2_9C (CR_D_2<<8)|0x9C
#define CR_D_2_9D (CR_D_2<<8)|0x9D
#define CR_D_2_9E (CR_D_2<<8)|0x9E
#define CR_D_2_9F (CR_D_2<<8)|0x9F
#define CR_D_2_A0 (CR_D_2<<8)|0xA0
#define CR_D_2_A1 (CR_D_2<<8)|0xA1
#define CR_D_2_A2 (CR_D_2<<8)|0xA2
#define CR_D_2_A3 (CR_D_2<<8)|0xA3
#define CR_D_2_A4 (CR_D_2<<8)|0xA4
#define CR_D_2_A5 (CR_D_2<<8)|0xA5
#define CR_D_2_A6 (CR_D_2<<8)|0xA6
#define CR_D_2_A7 (CR_D_2<<8)|0xA7
#define CR_D_2_A8 (CR_D_2<<8)|0xA8
#define CR_D_2_A9 (CR_D_2<<8)|0xA9
#define CR_D_2_AA (CR_D_2<<8)|0xAA
#define CR_D_2_AB (CR_D_2<<8)|0xAB
#define CR_D_2_AC (CR_D_2<<8)|0xAC
#define CR_D_2_AD (CR_D_2<<8)|0xAD
#define CR_D_2_AE (CR_D_2<<8)|0xAE
#define CR_D_2_AF (CR_D_2<<8)|0xAF
#define CR_D_2_B0 (CR_D_2<<8)|0xB0
#define CR_D_2_B1 (CR_D_2<<8)|0xB1
#define CR_D_2_B2 (CR_D_2<<8)|0xB2
#define CR_D_2_B3 (CR_D_2<<8)|0xB3
#define CR_D_2_B4 (CR_D_2<<8)|0xB4
#define CR_D_2_B5 (CR_D_2<<8)|0xB5
#define CR_D_2_B6 (CR_D_2<<8)|0xB6
#define CR_D_2_B7 (CR_D_2<<8)|0xB7
#define CR_D_2_B8 (CR_D_2<<8)|0xB8
#define CR_D_2_B9 (CR_D_2<<8)|0xB9
#define CR_D_2_BA (CR_D_2<<8)|0xBA
#define CR_D_2_BB (CR_D_2<<8)|0xBB
#define CR_D_2_BC (CR_D_2<<8)|0xBC
#define CR_D_2_BD (CR_D_2<<8)|0xBD
#define CR_D_2_BE (CR_D_2<<8)|0xBE
#define CR_D_2_BF (CR_D_2<<8)|0xBF
#define CR_D_2_C0 (CR_D_2<<8)|0xC0
#define CR_D_2_C1 (CR_D_2<<8)|0xC1
#define CR_D_2_C2 (CR_D_2<<8)|0xC2
#define CR_D_2_C3 (CR_D_2<<8)|0xC3
#define CR_D_2_C4 (CR_D_2<<8)|0xC4
#define CR_D_2_C5 (CR_D_2<<8)|0xC5
#define CR_D_2_C6 (CR_D_2<<8)|0xC6
#define CR_D_2_C7 (CR_D_2<<8)|0xC7
#define CR_D_2_C8 (CR_D_2<<8)|0xC8
#define CR_D_2_C9 (CR_D_2<<8)|0xC9
#define CR_D_2_CA (CR_D_2<<8)|0xCA
#define CR_D_2_CB (CR_D_2<<8)|0xCB
#define CR_D_2_CC (CR_D_2<<8)|0xCC
#define CR_D_2_CD (CR_D_2<<8)|0xCD
#define CR_D_2_CE (CR_D_2<<8)|0xCE
#define CR_D_2_CF (CR_D_2<<8)|0xCF
#define CR_D_2_D0 (CR_D_2<<8)|0xD0
#define CR_D_2_D1 (CR_D_2<<8)|0xD1
#define CR_D_2_D2 (CR_D_2<<8)|0xD2
#define CR_D_2_D3 (CR_D_2<<8)|0xD3
#define CR_D_2_D4 (CR_D_2<<8)|0xD4
#define CR_D_2_D5 (CR_D_2<<8)|0xD5
#define CR_D_2_D6 (CR_D_2<<8)|0xD6
#define CR_D_2_D7 (CR_D_2<<8)|0xD7
#define CR_D_2_D8 (CR_D_2<<8)|0xD8
#define CR_D_2_D9 (CR_D_2<<8)|0xD9
#define CR_D_2_DA (CR_D_2<<8)|0xDA
#define CR_D_2_DB (CR_D_2<<8)|0xDB
#define CR_D_2_DC (CR_D_2<<8)|0xDC
#define CR_D_2_DD (CR_D_2<<8)|0xDD
#define CR_D_2_DE (CR_D_2<<8)|0xDE
#define CR_D_2_DF (CR_D_2<<8)|0xDF
#define CR_D_2_E0 (CR_D_2<<8)|0xE0
#define CR_D_2_E1 (CR_D_2<<8)|0xE1
#define CR_D_2_E2 (CR_D_2<<8)|0xE2
#define CR_D_2_E3 (CR_D_2<<8)|0xE3
#define CR_D_2_E4 (CR_D_2<<8)|0xE4
#define CR_D_2_E5 (CR_D_2<<8)|0xE5
#define CR_D_2_E6 (CR_D_2<<8)|0xE6
#define CR_D_2_E7 (CR_D_2<<8)|0xE7
#define CR_D_2_E8 (CR_D_2<<8)|0xE8
#define CR_D_2_E9 (CR_D_2<<8)|0xE9
#define CR_D_2_EA (CR_D_2<<8)|0xEA
#define CR_D_2_EB (CR_D_2<<8)|0xEB
#define CR_D_2_EC (CR_D_2<<8)|0xEC
#define CR_D_2_ED (CR_D_2<<8)|0xED
#define CR_D_2_EE (CR_D_2<<8)|0xEE
#define CR_D_2_EF (CR_D_2<<8)|0xEF
#define CR_D_2_F0 (CR_D_2<<8)|0xF0
#define CR_D_2_F1 (CR_D_2<<8)|0xF1
#define CR_D_2_F2 (CR_D_2<<8)|0xF2
#define CR_D_2_F3 (CR_D_2<<8)|0xF3
#define CR_D_2_F4 (CR_D_2<<8)|0xF4
#define CR_D_2_F5 (CR_D_2<<8)|0xF5
#define CR_D_2_F6 (CR_D_2<<8)|0xF6
#define CR_D_2_F7 (CR_D_2<<8)|0xF7
#define CR_D_2_F8 (CR_D_2<<8)|0xF8
#define CR_D_2_F9 (CR_D_2<<8)|0xF9
#define CR_D_2_FA (CR_D_2<<8)|0xFA
#define CR_D_2_FB (CR_D_2<<8)|0xFB
#define CR_D_2_FC (CR_D_2<<8)|0xFC
#define CR_D_2_FD (CR_D_2<<8)|0xFD
#define CR_D_2_FE (CR_D_2<<8)|0xFE
#define CR_D_2_FF (CR_D_2<<8)|0xFF

#endif /* _CBIOS_REG_H_ */

